'--------------------------------------------------------------------
' FButton (Pushbutton)
'--------------------------------------------------------------------

Type FButton Extends Control	
	public: 	
	Declare Property TextPos(Byval value as Integer)
	Declare Property TextPos as Integer   
   Declare Sub Create(ByVal hParent As HWND, Capt As String,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor  
   ' Events	
	onClick As Sub()	 
   Declare Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Declare Sub Image(value as String)
   Declare Sub LoadBmp( value as String)
   Private:
   As Integer  b_TextPos	= 0
   As Integer 	b_Bitmap 	= 0
	As HDC 		b_dc			= 0
	As Integer  b_bmWidth 	= 0
	As Integer  b_bmHeight	= 0
End Type
Constructor FButton	
	this.b_Bitmap 	= FALSE
	this.b_TextPos	= 0
	this.b_dc		= 0
  	this.Handle 	= 0
  	this.ExStyle 	= 0	
	this.Style 	 	=  WS_CHILD Or WS_VISIBLE Or BS_PUSHBUTTON Or BS_OWNERDRAW Or WS_TABSTOP	
End Constructor

Destructor FButton  
	If this.b_dc Then
		DeleteDC(this.b_dc)
	EndIf
   this.Handle  = 0
End Destructor
Property FButton.TextPos(Byval value as Integer)
	this.b_TextPos = value
End Property
Property FButton.TextPos as Integer
	Return this.b_TextPos
End Property
Sub FButton.LoadBmp( value as String)
	
		Dim As HDC hDC	
		
		this.b_Bitmap = FALSE
			
		Dim As FBILoad Ptr bml
   	bml = New FBILoad
   	   	
	   If InStr(value,".") = 0 Then  	' Resource 
			bml->LoadBitmapRes( value)
	   Else										' Deteiname
	   	bml->LoadBitmapFile(value)
	   End If
	  
	   this.b_bmWidth 	= bml->bWidth
	   this.b_bmHeight  	= bml->bHeight 
	  	    
	   If bml->bBitmap Then
	 		this.b_Bitmap = TRUE
	 	Else
	 		 Delete bml	
	 		 Exit Sub
	   EndIf	
		
		If this.b_dc <> 0 Then
  			DeleteDC(this.b_dc)
		End If	
   	
	   hDC 		= GetDC(GetDesktopWindow)						
   	this.b_dc	= CreateCompatibleDC(hDC)
		SelectObject(this.b_dc,bml->bBitmap)

		ReleaseDC(GetDesktopWindow,hDC)
	   Delete bml		
End Sub

Sub FButton.Image( value as String)
	' kann JPG,PNG,GIF,TIFF und Bitmap laden
	this.b_Bitmap = FALSE	' wenn Fehler - wird nur Text gezeichnet
	
	If isFileExist(value) = FALSE Then
		MessageBox(0,"Image Datei nicht gefunden","Fehler",MB_ICONERROR)
		Exit sub
	EndIf
	
	Dim As ushort r,g,b
	
	r = GetRValue(this.Color)
	g = GetGValue(this.Color)
	b = GetBValue(this.Color)
	
	Dim As HBITMAP hBmp
	Dim As FImage Ptr img
	img = New FImage			' FImage Object
	
	img->bkColor 		= RGBA(r,g,b,255)
	img->LoadImg(value)
	
	this.b_bmWidth 	= img->ImgWidth 
	this.b_bmHeight  	= img->ImgHeight 
					
   this.b_dc	= CreateCompatibleDC(img->DC)
   hBmp = CreateCompatibleBitmap(img->DC,img->ImgWidth,img->ImgHeight)
	SelectObject(this.b_dc,hBmp)
	DeleteObject(hBmp)
	
	If this.b_dc Then
		img->ImgCopy(this.b_dc, 0, 0 )
		this.b_Bitmap = TRUE	 ' kein Fehler - Bild wird (oder mit Text) gezeichnet
	EndIf
	
	Delete img	 'FImage lschen
		
End Sub
Function FButton.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
	
   Function = 0 
  
   Select case uMsg   	
    	Case WM_ENABLE 
   		this.Enabled = wParam
   		Exit Function
   		
   	Case WM_SETFONT,WM_SETTEXT
   		If this.Handle Then
   			Function = SendMessage(this.Handle,uMsg,wParam,lParam)
   		End If
    		Exit Function 
    		
   	Case WM_SIZE
   		If this.Handle Then
    			MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
   		End If
    		Exit Function 
    		
   	Case WM_COMMAND		  		
   		If IsChild( hWnd, Cast(HANDLE, lParam)) Then 
   			If this.onClick Then
  					onClick()
   			End If  							
   		Function = 0
   		Exit Function   
   		EndIf
   				
   	Case WM_DRAWITEM
   		Dim As LPDRAWITEMSTRUCT lpdis = Cast(Any Ptr, lParam)
   		Dim As HANDLE hCtrl = lpdis->hwndItem
   		Dim As Integer x, y
   		Dim As RECT rc
   		
   		If IsChild(hWnd,hCtrl) Then
   			
   			rc = lpdis->rcItem
   			Dim hBr As HBRUSH
				
   			SetBkColor(lpdis->hDC,this.Color)
   			hBr = CreateSolidBrush(this.Color)
   			FillRect(lpdis->hDC,@lpdis->rcItem,hBr)
   			DeleteObject(hBr)
	   		   		
	   		if lpdis->itemState and ODS_SELECTED  Then           
	            DrawEdge(lpdis->hDC,@lpdis->rcItem,  EDGE_SUNKEN ,BF_RECT)            
	   		Else 
	         	DrawEdge(lpdis->hDC,@lpdis->rcItem,  EDGE_RAISED ,  BF_RECT )
	   		End If  
	   		
	   		
	   	If (this.b_Bitmap<>0) And (Len(this.Caption) = 0) Then 	' Nur Bild
   			x = Int((this.Width - this.b_bmWidth)/2)
				y = Int((this.Height - this.b_bmHeight)/2)
	   		
				BitBlt(lpdis->hDC,x,y ,this.b_bmWidth + x,this.b_bmHeight + y ,this.b_dc,0,0,SRCCOPY)	
				
   		ElseIf (this.b_Bitmap=0) And (Len(this.Caption)<> 0) Then	' Nur Text
   			SetBkMode(lpdis->hDC, TRANSPARENT)
         	SetTextColor(lpdis->hDC,this.TextColor)
   			DeleteObject(SelectObject(lpdis->hDC,this.Font)) 
   			DrawText(lpdis->hDC,this.Caption, -1, @lpdis->rcItem, DT_SINGLELINE or DT_CENTER or DT_VCENTER )
   			
   		ElseIf (this.b_Bitmap<>0) And (Len(this.Caption)<> 0) Then	'  Bild + Text
   			If b_TextPos = TRUE Then											' Bild oben
		   		rc.left 	= Int((lpdis->rcItem.right - this.b_bmWidth) /2)
		   		rc.top  	= lpdis->rcItem.top + 5 							' Padding oben
		   		rc.right	= this.b_bmWidth
		   		rc.bottom= this.b_bmHeight	
	         	lpdis->rcItem.Top = this.b_bmHeight + 8 
   			Else																		' Bild links voreingestellt
         		rc.left 	= 5
		   		rc.top  	= Int((lpdis->rcItem.bottom - this.b_bmHeight) /2)
		   		rc.right	= this.b_bmWidth
		   		rc.bottom= this.b_bmHeight   	
	         	lpdis->rcItem.left = lpdis->rcItem.left + 5 + this.b_bmWidth
   			EndIf	
   			
         	BitBlt(lpdis->hDC,rc.left,rc.top,rc.right,rc.bottom,this.b_dc,0,0,SRCCOPY)	
         	SetBkMode(lpdis->hDC, TRANSPARENT)
         	SetTextColor(lpdis->hDC,this.TextColor)
         	DeleteObject(SelectObject(lpdis->hDC,this.Font))        	
         	
   			DrawText(lpdis->hDC,this.Caption, -1, @lpdis->rcItem, DT_SINGLELINE or DT_CENTER or DT_VCENTER )	
   		EndIf 
   		
   		GetClientRect(hCtrl,@rc)
   		rc.left +=3 
   		rc.top +=3
   		rc.right -=3
   		rc.bottom -=3
  
   		If lpdis->itemState and ODS_FOCUS  Then  			
   			DrawFocusRect(lpdis->hDC,@rc) 
   		EndIf
   	Endif	
			Function = TRUE
			Exit Function   	
   	
   End Select
  
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
end Function

Sub FButton.Create(ByVal hParent As HWND, Capt As String,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	        
   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
         
   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE Or WS_CHILD  , x, y, w , h , _                    
                          hParent , NULL, hInst , NULL )
                                                   
   SetWindowLong(this.CtHandle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz                        
                                                                    
   If this.CtHandle  Then  		
   	this.Left	 = x
		this.Top		 = y
   	this.Width 	 = w
  		this.Height  = h
   	this.Parent  = hParent  	
   Else
   	MessageBox(0,"Fehler - Create Button","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
                               
   this.Handle = CreateWindowEx( NULL , "BUTTON" , Capt, this.Style  ,  0, 0, w, h , this.CtHandle , NULL, hInst , NULL )                                            
   If this.Handle = 0 Then
   	MessageBox(0,"Fehler - Create Button","Fehler",MB_ICONERROR)
   EndIf  
   this.Caption = Capt  
   
End Sub
