'-----------------------------------------------------------------------------------
' Canvas
'-----------------------------------------------------------------------------------

Type FCanvas Extends Object
	
	public: 	  
  
   Declare Property Parent As HWND
   Declare Property chDC As HDC
   Declare Property cImgDC As HDC
   Declare Property cImageWidth  As Integer
   Declare Property cImageHeight  As Integer
   Declare Property cWidth  As Integer
   Declare Property cHeight  As Integer 
   Declare Property chFont  As HFONT   
   Declare Property cImageBKColor(ByVal value  As UInteger)
   Declare Property cImageBKColor  As UInteger
   Declare Property Cursor(ByVal value As Integer)
 	Declare Property Cursor As Integer
   Declare Property cPenColor(ByVal value  As COLORREF)
   Declare Property cPenColor  As COLORREF
   Declare Property cPenWidth(ByVal value  As Integer)
   Declare Property cPenWidth As Integer
   Declare Property cPenStyle(ByVal value  As Integer)
   Declare Property cPenStyle  As Integer
   Declare Property cTextColor(ByVal value As COLORREF)
   Declare Property cTextColor  As COLORREF
   Declare Property cRop  As UInteger
   Declare Property cRop(ByVal value As UInteger)
     
   Declare Sub cEllipse(ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer)
   Declare Sub cRectangle(ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer)
   Declare Sub cLine(ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer)	
   Declare Sub cPolyLine(ByVal pt As Point Ptr, ByVal nCount As Integer, ByVal fill As Integer)
   Declare Sub cFillRect(ByVal canv As RECT Ptr )
   Declare Sub cFont(Face As String,ByVal size As Integer,ByVal bold As Integer,ByVal italic As Integer,ByVal underlin As Integer)
   Declare Sub cRestoreFont
	Declare Sub cTextOut(ByVal x As Integer,ByVal y As Integer,sText As String  )
	Declare Sub cTextRect (ByVal canvRC As RECT Ptr ,sText As String ,ByVal BGColor As Integer)
	Declare Sub cCopyRect(ByVal canv As RECT Ptr , ByVal quellDC As HDC, ByVal quellRC As RECT Ptr)
	Declare Sub cAttach(ByVal hWnd As HWND)
	Declare Sub cSaveToFile( filename As String)
	Declare Sub cImageFromFile( filename As String)
	Declare Sub cHatchBrush(ByVal fnStyle As integer ,ByVal nColor As COLORREF)
	Declare Sub cSolidBrush( ByVal nColor As COLORREF)
	Declare Sub cPatternBrush( sName As String)
	Declare Sub cSize(ByVal w As Integer,ByVal h As Integer)
	Declare Function cTextHeight( s As String) As Integer
   Declare Function cTextWidth( s As String) As Integer 
   Declare Constructor
   Declare Destructor
  
	Private: 
   As Point 	b_Pt(0 To 64)		' Polyline
   As HWND		b_Parent 	= 0
   As HBRUSH	b_Brush		= 0
   As HBITMAP  b_BrushBmp  = 0
   As HPEN		b_Pen			= 0
   As HDC		b_hDC			= 0
   As HDC		b_MemDC		= 0
   As UInteger b_OldCur		= 0
   As COLORREF b_BrushColor = &Hffffff
   As COLORREF b_PenColor 	= &H0
   As COLORREF b_Textcolor	= &H0
   As Integer  b_PenWidth 	= 1
   As Integer  b_PenStyle 	= PS_SOLID
   As Integer	b_ImageWidth= 0
   As Integer	b_ImageHeight=0
   As Integer	b_cWidth		= 0
   As Integer	b_cHeight	=0
   As UInteger b_ImageBKColor = &HFFFFFFFF
   As Integer	b_Cursor		= 0
   As HFONT		b_hFont		= 0
   As HFONT    b_oldFont   = 0
	As UInteger b_Rop			= SRCCOPY	 
End Type

Constructor FCanvas
	this.b_Brush	= CreateSolidBrush(&HFFFFFF)
	this.b_Pen		= CreatePen(PS_SOLID,1,&H0)
	this.b_Cursor	= 0
	this.b_hFont	= 0	
  	SetTextColor(this.b_hDC,this.b_Textcolor)	
  	SetBkMode(this.b_hDC,TRANSPARENT)
end Constructor
Destructor FCanvas
	If this.b_OldCur Then
		SetClassLong(this.Parent,GCL_HCURSOR,CInt(LoadCursor(0, IDC_ARROW)))
	EndIf
	If this.b_Brush Then
		DeleteObject(this.b_Brush)
	EndIf
	If this.b_Pen Then
		DeleteObject(this.b_Pen)
	EndIf
	If this.b_hFont Then
		DeleteObject(this.b_hFont)
	EndIf
	If this.b_BrushBmp Then
		DeleteObject(this.b_BrushBmp)
	EndIf
	If this.b_MemDC Then
		DeleteDC(this.b_MemDC)
	EndIf
	If this.b_hDC Then
		ReleaseDC(this.b_Parent,this.b_hDC)
	EndIf
	Erase b_Pt
	this.b_OldCur = 0
	this.b_Brush = 0
	this.b_BrushBmp = 0
	this.b_Pen	 = 0
	this.b_hFont  = 0
   this.b_Parent = 0
   this.b_hDC	 = 0 
	this.b_oldFont = 0
end Destructor
Sub FCanvas.cAttach(ByVal hParent As HWND)
	Dim As RECT rc
	If (this.b_Parent <> 0) And (this.b_hDC <> 0) Then
		ReleaseDC(this.b_Parent,this.b_hDC)
		this.b_Parent	= 0	
	  	this.b_hDC		= 0
	EndIf
	If IsWindow(hParent) Then
		GetClientRect(hParent,@rc)	
		b_cWidth = rc.right
		b_cHeight= rc.bottom
		this.b_Parent	= hParent	
	  	this.b_hDC		= GetDC(hParent)
  	EndIf
End Sub
Property FCanvas.chFont As HFONT   
	Return this.b_hFont
End Property
Property FCanvas.cImageWidth  As Integer
	Return this.b_ImageWidth 
End Property
Property FCanvas.cImageHeight  As Integer
	Return this.b_ImageHeight
End Property
Property FCanvas.cWidth  As Integer
	Dim As RECT rc
	If IsWindow(this.b_Parent) Then
		GetClientRect(this.b_Parent,@rc)	
		this.b_cWidth = rc.right
	End if		
	Return this.b_cWidth 
End Property
Property FCanvas.cHeight  As Integer
	Dim As RECT rc
	If IsWindow(this.b_Parent) Then
		GetClientRect(this.b_Parent,@rc)	
		this.b_cHeight = rc.bottom
	End If
	Return this.b_cHeight
End Property  
Property  FCanvas.cImageBKColor(ByVal value  As UInteger)
	this.b_ImageBKColor = value
End Property
Property  FCanvas.cImageBKColor  As UInteger
	Return this.b_ImageBKColor
End Property
   
Property FCanvas.cRop  As UInteger
	Return this.b_Rop
End Property
Property FCanvas.cRop(ByVal value As UInteger)
	If this.b_hDC Then
		this.b_Rop = value
	 	SetROP2(this.b_hDC,this.b_Rop)
	End If
End Property
Property FCanvas.cImgDC As HDC   
	Return this.b_MemDC 
End Property
Property FCanvas.chDC As HDC
   Return this.b_hDC 
End Property
Property FCanvas.Parent As HWND
 	Return this.b_Parent
End Property
Property FCanvas.cTextColor(ByVal value As COLORREF)
	this.b_Textcolor = value
	If this.b_hDC Then
		SetTextColor(this.b_hDC,this.b_Textcolor)
	EndIf
End Property
Property FCanvas.cTextColor As COLORREF
	Return this.b_Textcolor
End Property
Property FCanvas.Cursor(ByVal value As Integer)
	Dim As HCURSOR hcur
	
	Select Case value
		Case 0			
			this.b_Cursor = 0
			hcur = LoadCursor(0, IDC_ARROW)
			this.b_OldCur = SetClassLong(this.Parent,GCL_HCURSOR,CInt(hcur)) 
		Case 1
			this.b_Cursor = 1
			hcur = LoadCursor(0, IDC_CROSS)
			this.b_OldCur = SetClassLong(this.Parent,GCL_HCURSOR,CInt(hcur)) 
		Case 2
			this.b_Cursor = 2
			hcur = LoadCursor(0, IDC_SIZEALL)
			this.b_OldCur = SetClassLong(this.Parent,GCL_HCURSOR,CInt(hcur)) 
		Case 3
			this.b_Cursor = 3
			hcur = LoadCursor(0, IDC_SIZENESW )
			this.b_OldCur = SetClassLong(this.Parent,GCL_HCURSOR,CInt(hcur)) 
		Case 4	
			this.b_Cursor = 4 
			hcur = LoadCursor(0, IDC_SIZENS)
			this.b_OldCur = SetClassLong(this.Parent,GCL_HCURSOR,CInt(hcur)) 
		Case 5
			this.b_Cursor = 5
			hcur = LoadCursor(0, IDC_SIZENWSE)
			this.b_OldCur = SetClassLong(this.Parent,GCL_HCURSOR,CInt(hcur)) 
		Case 6
			this.b_Cursor = 6
			hcur = LoadCursor(0, IDC_SIZEWE)
			this.b_OldCur = SetClassLong(this.Parent,GCL_HCURSOR,CInt(hcur)) 
		Case 7
			this.b_Cursor = 7
			hcur = LoadCursor(0, IDC_HAND)
			SetClassLong(this.Parent,GCL_HCURSOR,CInt(hcur)) 
		Case Else
			hcur = LoadCursor(0, IDC_ARROW)
			this.b_OldCur = SetClassLong(this.Parent,GCL_HCURSOR,CInt(hcur)) 
			this.b_Cursor = 0
	End Select
	SetCursor(hcur)
End Property
Property FCanvas.Cursor As Integer
	Return this.b_Cursor
End Property

Property FCanvas.cPenColor(ByVal value  As COLORREF)
	If this.b_hDC Then
		this.b_PenColor = value
		If this.b_Pen Then
			DeleteObject(this.b_Pen)
			this.b_Pen = 0
		EndIf	
		this.b_Pen = CreatePen(this.b_PenStyle,this.b_PenWidth,this.b_PenColor)
		DeleteObject(SelectObject(this.b_hDC,this.b_Pen))
	End If
End Property
Property FCanvas.cPenColor  As COLORREF
	Return this.b_PenColor
End Property
Property FCanvas.cPenWidth(ByVal value  As Integer)
	If this.b_hDC Then
		this.b_PenWidth = value
		If this.b_Pen Then
			DeleteObject(this.b_Pen)
			this.b_Pen = 0
		EndIf	
		this.b_Pen = CreatePen(this.b_PenStyle,this.b_PenWidth,this.b_PenColor)
		DeleteObject(SelectObject(this.b_hDC,this.b_Pen))
	End If
End Property
Property FCanvas.cPenWidth As Integer
	Return this.b_PenWidth
End Property
Property FCanvas.cPenStyle(ByVal value  As Integer)
	If this.b_hDC Then
	Select Case value
		Case 0
			this.b_PenStyle = PS_NULL	
		Case 1
			this.b_PenStyle = PS_SOLID	
		Case 2
			this.b_PenStyle = PS_DASH	
		Case 3
			this.b_PenStyle = PS_DOT	
		Case 4
			this.b_PenStyle = PS_DASHDOT	
		Case 4
			this.b_PenStyle = PS_DASHDOTDOT			
	End Select
	If this.b_Pen Then
		DeleteObject(this.b_Pen)
		this.b_Pen = 0
	EndIf	
		this.b_Pen = CreatePen(this.b_PenStyle,this.b_PenWidth,this.b_PenColor)
		DeleteObject(SelectObject(this.b_hDC,this.b_Pen))
	End If
End Property
Property FCanvas.cPenStyle As Integer
	Return this.b_PenStyle
End Property
Sub FCanvas.cSize(ByVal w As Integer,ByVal h As Integer)
	this.b_cWidth	= w
   this.b_cHeight	= h
End Sub
Sub  FCanvas.cEllipse(ByVal x1 As Integer, ByVal y1 As Integer, ByVal w As Integer, ByVal h As Integer)		
	If this.b_hDC Then
		Ellipse( this.b_hDC , x1 , y1 , w + x1, h + y1)			
	EndIf
End Sub
Sub  FCanvas.cRectangle(ByVal x1 As Integer, ByVal y1 As Integer, ByVal w As Integer, ByVal h As Integer)
	If this.b_hDC Then
		Rectangle(this.b_hDC, x1 , y1 , w + x1, h + y1)		
	EndIf	
End Sub
Sub  FCanvas.cLine(ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer)
	If this.b_hDC Then		
		MoveToEx(this.b_hDC,x1 , y1 , NULL)	
		LineTo(this.b_hDC,x2 , y2 )	
	EndIf	
End Sub
Sub FCanvas.cFillRect(ByVal canv As RECT Ptr )
	If this.b_hDC Then		
		canv->Right  = canv->Right  + canv->Left
		canv->bottom = canv->bottom + canv->top		
		FillRect(this.b_hDC,canv,this.b_Brush)
	EndIf	
End Sub
Sub FCanvas.cPolyLine(ByVal pt As Point Ptr, ByVal nCount As Integer, ByVal fill As integer)
	If nCount > 32 Then Exit Sub
	If this.b_hDC Then
		BeginPath(this.b_hDC)
         Polyline(this.b_hDC,pt,nCount)
      EndPath(this.b_hDC)
      If fill Then
			StrokeAndFillPath(this.b_hDC)
      Else
      	StrokePath(this.b_hDC)
      End If	
	EndIf	
End Sub
Sub FCanvas.cTextOut(ByVal x As Integer,ByVal y As Integer, sText As String)
	SetBkMode(this.b_hDC,TRANSPARENT)
	TextOut(this.b_hDC , x , y , StrPtr(sText) , Len(sText) )	
End Sub
Sub FCanvas.cTextRect (ByVal canvRC As RECT Ptr ,sText As String ,ByVal BGColor As Integer)
	If this.b_hDC Then
		canvRC->Right  = canvRC->Right  + canvRC->Left
		canvRC->bottom = canvRC->bottom + canvRC->top		 
		If BGColor >= 0 Then
			Dim As HBRUSH hBr = CreateSolidBrush(BGColor)
			FillRect(this.b_hDC,canvRC,hBr)
			DeleteObject(hBr)
			SetBkMode(this.b_hDC,TRANSPARENT)
			DrawText(this.b_hDC,StrPtr(sText),Len(sText),canvRC,DT_CENTER Or DT_VCENTER Or DT_SINGLELINE )
		Else
			SetBkMode(this.b_hDC,TRANSPARENT)
			DrawText(this.b_hDC,StrPtr(sText),Len(sText),canvRC,DT_CENTER Or DT_VCENTER Or DT_SINGLELINE )
		EndIf			
	EndIf
End Sub
Sub FCanvas.cCopyRect(ByVal canvRC As RECT Ptr , ByVal quellDC As HDC,ByVal quellRC As RECT Ptr)
	If this.b_hDC Then
		StretchBlt(this.b_hDC,canvRC->left,canvRC->top,canvRC->Right,canvRC->bottom , _
			 quellDC ,quellRC->left,quellRC->top,quellRC->Right,quellRC->bottom ,this.b_Rop )
	EndIf
End Sub
Function FCanvas.cTextHeight( s As String) As Integer
	Dim As SIZEL size	
	If this.b_hDC Then
		GetTextExtentPoint32(this.b_hDC,StrPtr(s),Len(s),@size)
		Return size.cy
	Else
		Return 0
	EndIf
End Function
Function FCanvas.cTextWidth( s As String) As Integer  
	Dim As SIZEL size	
	If this.b_hDC Then
		GetTextExtentPoint32(this.b_hDC,StrPtr(s),Len(s),@size)
		Return size.cx
	Else
		Return 0
	EndIf
End Function

Sub FCanvas.cHatchBrush(ByVal fnStyle As integer ,ByVal nColor As COLORREF)
	this.b_BrushColor = nColor
	this.b_Brush = CreateHatchBrush(fnStyle,nColor)
	DeleteObject(SelectObject(this.b_hDC,this.b_Brush))
End Sub
Sub FCanvas.cSolidBrush( ByVal nColor As COLORREF)
	this.b_BrushColor = nColor
	this.b_Brush = CreateSolidBrush(nColor)
	DeleteObject(SelectObject(this.b_hDC,this.b_Brush))	
End Sub
	
Sub FCanvas.cPatternBrush( sName As String)
	Dim As FBILoad Ptr bml
	bml = New FBILoad
	
	If InStr(sName,".") = 0 Then  	' Resource 
		bml->LoadBitmapRes(sName)
	Else										' Deteiname
		bml->LoadBitmapFile(sName)
	End If
	
	If bml->bBitmap Then
		
		If this.b_BrushBmp Then
			DeleteObject(this.b_BrushBmp)
		EndIf
		
		this.b_BrushBmp = bml->CopyhBitmap
		
		If this.b_Brush Then
			DeleteObject(this.b_Brush)
		EndIf
		
		this.b_Brush  = CreatePatternBrush( this.b_BrushBmp )
		DeleteObject(SelectObject(this.b_hDC,this.b_Brush))
	Else
		MessageBox(0,"PatternBmp wurde nicht gefunden","Fehler",MB_ICONERROR)
	EndIf	
	
	Delete bml
End Sub
Sub FCanvas.cFont(Face As String,ByVal size As Integer,ByVal bold As Integer,ByVal italic As Integer,ByVal underlin As Integer)
	Dim lgFont AS LOGFONT 

	lgFont.lfFaceName = Face
	lgFont.lfHeight 	= -MulDiv(size, GetDeviceCaps(GetDC(0), LOGPIXELSY), 72)
	lgFont.lfWeight 	= IIf(bold,800,400)
	lgFont.lfItalic 	= IIf(italic,1,0)
	lgFont.lfStrikeOut = 0
	lgFont.lfUnderline = IIf(underlin,1,0)
	If this.b_hFont Then
		DeleteObject(this.b_hFont)
	EndIf
	this.b_hFont = (CreateFontIndirect(@lgFont))		
	this.b_oldFont = SelectObject(this.b_hDC,this.b_hFont)	
End Sub
Sub FCanvas.cRestoreFont
	DeleteObject(SelectObject(this.b_hDC,this.b_oldFont))
	this.b_hFont = 0
	this.b_oldFont = 0
End Sub

Sub FCanvas.cSaveToFile( filename As String)
	Dim As RECT rc 
	Dim As HDC hmemDc
   Dim As HBITMAP memBmp
	Dim As BITMAP bm 
   Dim As BITMAPFILEHEADER bmfh
   Dim As BITMAPINFO pbmi  
   Dim As HANDLE hf                 ' file handle 
   Dim As Integer dwTmp
   
   GetClientRect(this.Parent,@rc)

   hmemDc=CreateCompatibleDC(this.chDC)
    
   ZeroMemory(@pbmi,sizeof(BITMAPINFOHEADER))   
   pbmi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER) 
   pbmi.bmiHeader.biWidth = rc.right
   pbmi.bmiHeader.biHeight = rc.bottom
   pbmi.bmiHeader.biPlanes = 1
   pbmi.bmiHeader.biBitCount = 24 
   pbmi.bmiHeader.biCompression = BI_RGB
   
   memBmp=CreateDIBSection( hmemDc ,@pbmi,DIB_RGB_COLORS,0,0,0)
   GlobalLock(memBmp)
   SelectObject(hmemDc, memBmp)
   GetObject(memBmp, SIZEOF(bm), @bm)
   BitBlt(hmemDc,0,0,bm.bmWidth, bm.bmHeight ,this.chDC ,0,0,SRCCOPY)
    
   pbmi.bmiHeader.biSizeImage =  bm.bmWidthBytes * bm.bmHeight
   pbmi.bmiHeader.biClrImportant = 0 						
   pbmi.bmiHeader.biXPelsPerMeter = 0
   pbmi.bmiHeader.biYPelsPerMeter = 0
   pbmi.bmiHeader.biClrImportant = 0
	pbmi.bmiHeader.biWidth = bm.bmWidth
   pbmi.bmiHeader.biHeight = bm.bmHeight
   
   ZeroMemory(@bmfh,sizeof(BITMAPFILEHEADER))
   bmfh.bfOffBits=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)
   bmfh.bfSize=sizeof(BITMAPFILEHEADER)+sizeof(BITMAPINFOHEADER)+ (bm.bmWidthBytes * bm.bmHeight)

   bmfh.bfType=&H4d42
   bmfh.bfReserved1 = 0
   bmfh.bfReserved2 = 0

	hf = CreateFile(filename, GENERIC_READ OR GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL) 
 
   If hf = INVALID_HANDLE_VALUE Then  
     MessageBox(0,"INVALID_HANDLE_VALUE","Info",MB_OK)
   End If     
    ' Copy  BITMAPFILEHEADER in .BMP file. 
   if WriteFile(hf, @bmfh, sizeof(BITMAPFILEHEADER), @dwTmp, NULL) = 0 Then
   	 MessageBox(0,"Fehler beim Schreiben BITMAPFILEHEADER","Info",MB_OK)
   EndIf
   
   'Copy BITMAPINFOHEADER  in .BMP file.
   if WriteFile(hf, @pbmi, sizeof(BITMAPINFOHEADER) , @dwTmp,  NULL)  = 0 Then
      MessageBox(0,"Fehler beim Schreiben BITMAPINFOHEADER","Info",MB_OK)
   EndIf
 
   ' Copy Bild-Daten in .BMP file. 
    if WriteFile(hf,Cast(Byte Ptr, bm.bmBits), (bm.bmWidthBytes * bm.bmHeight) , @dwTmp,  NULL)  = 0 Then
      MessageBox(0,"Fehler beim Schreiben Bild-Daten","Info",MB_OK)
   EndIf
   
	CloseHandle(hf) 
	 
   DeleteDC(hmemDc)
   GlobalUnlock(memBmp)
   DeleteObject(memBmp)
   
End Sub

Sub FCanvas.cImageFromFile( filename As String)
	
	If isFileExist(filename) = FALSE Then
		MessageBox(0,"Image Datei nicht gefunden","Fehler",MB_ICONERROR)
		Exit sub
	EndIf
	
	Dim As HBITMAP bitmap
	Dim As FImage Ptr img
	Dim As ushort r,g,b
	
	
	r = GetRValue(this.cImageBKColor)
	g = GetGValue(this.cImageBKColor)
	b = GetBValue(this.cImageBKColor)
	
	img = New FImage			' FImage Object
	
	img->bkColor = RGBA(r,g,b,255)
	img->LoadImg(filename)
	
	this.b_ImageWidth 	= img->ImgWidth 
	this.b_ImageHeight  	= img->ImgHeight 
	
	If this.b_MemDC <> 0 Then
  		DeleteDC(this.b_MemDC)
	End If
	
   this.b_MemDC = CreateCompatibleDC(this.b_hDC)
   bitmap = CreateCompatibleBitmap(this.b_hDC,this.b_ImageWidth,this.b_ImageHeight)
	SelectObject(this.b_MemDC,bitmap)
	DeleteObject(bitmap)	
	
	img->ImgCopy(this.b_MemDC, 0, 0 )
	
	Delete img
	
End Sub
