'--------------------------------------------------------------------
' 			Combobox
'-------------------------------------------------------------------- 
Type FComboBox Extends Control
	
	public:
		    
   Declare Property GetSelString As String
   Declare Property GetSelItem As Integer
   Declare Property GetItemCount As Integer
   DECLARE  FUNCTION CtrlMsgFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT  
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Sub SelItem(ByVal value As Integer)
   Declare Sub SelStrItem( value As String)
   Declare Sub AddString(value As String) 
   Declare Sub Clear
   Declare Sub DelString(ByVal item As Integer)
	Declare Constructor
   Declare Destructor
   ' Events	
	onSelChange As Sub(ByVal item As UInteger, szItem As ZString)	
	Private: 
   As HWND		b_Parent  	= 0
   As HBRUSH	b_Brush		= 0
End Type
Constructor FComboBox	
  	this.Handle  = 0
  	this.ExStyle = WS_EX_CLIENTEDGE
	this.Style 	 = WS_CHILD Or WS_VISIBLE  Or CBS_SORT Or WS_TABSTOP  Or CBS_DROPDOWNLIST Or CBS_NOINTEGRALHEIGHT Or WS_VSCROLL 

end Constructor
Destructor FComboBox  
   If this.b_Brush Then
		DeleteObject(this.b_Brush)
   EndIf
	this.Handle = 0
end Destructor
Property FComboBox.GetSelString As String
	 If this.Handle Then
	 	Dim item As Integer
	 	Dim szItem As ZString * MAX_PATH
		item = SendMessage(this.Handle,CB_GETCURSEL,0,0)
	   If item  <> LB_ERR Then
	   	SendMessage(this.Handle,CB_GETLBTEXT,item,CInt(@szItem))
	   	Return szItem
	   Else
	   	szItem = ""
	   	Return szItem
	   EndIf
	 End If
End Property
Property FComboBox.GetSelItem As Integer
	 If this.Handle Then
		return SendMessage(this.Handle,CB_GETCURSEL,0,0)
	 End If
End Property
Property FComboBox.GetItemCount As Integer
	 If this.Handle Then
		return SendMessage(this.Handle,CB_GETCOUNT,0,0)
	 End If
End Property

Sub FComboBox.AddString(value As String) 
	If this.Handle Then
		Dim  sItem As ZString * 128
		sItem = value
		SendMessage(this.Handle,CB_ADDSTRING,0,CInt(@sItem))
		SendMessage(this.Handle,CB_SETCURSEL,0,0)
	EndIf
End Sub
Sub FComboBox.SelItem(ByVal value As Integer) 
	If this.Handle Then
		SendMessage(this.Handle,CB_SETCURSEL ,value, 0 )	
		SetFocus(this.Handle)	
	EndIf
End Sub
Sub FComboBox.Clear
	If this.Handle Then
		SendMessage(this.Handle, CB_RESETCONTENT ,0,0)
	EndIf
End Sub
Sub FComboBox.DelString(ByVal item As Integer)
	If this.Handle Then
		SendMessage(this.Handle, CB_DELETESTRING  ,item,0)
	EndIf
End Sub
Sub FComboBox.SelStrItem( value As String)
	Dim szFind As ZString * 32
	Dim As Integer retVal 
	
	szFind = value
	If this.Handle Then
		retVal = SendMessage(this.Handle, CB_FINDSTRING ,-1,Cast(WPARAM, @szFind)) 
		If retVal <> CB_ERR Then
   		SendMessage(this.Handle,CB_SETCURSEL ,retVal, 0 )	
		EndIf
	EndIf
	
End Sub
Function FComboBox.CtrlMsgFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
    
   Dim As UInteger item 
   Dim szItem As ZString * MAX_PATH 
   
   Select case uMsg 
   	CASE WM_ENABLE
         this.Enabled = wParam
         EXIT FUNCTION

   	Case WM_SETFONT,WM_SETTEXT
         IF this.Handle THEN
             FUNCTION = SendMessage(this.Handle,uMsg,wParam,lParam)
         END IF
         EXIT FUNCTION

   	Case WM_SIZE
         IF this.Handle THEN
             MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
         END IF
         EXIT Function
         
      Case WM_ERASEBKGND 
         Dim As RECT rc
         GetClientRect(hWnd,@rc)
         FillRect(Cast(HDC,wParam),@rc,GetStockObject(NULL_BRUSH))
         Function = TRUE
         Exit Function
         
      Case WM_CTLCOLOREDIT
			SetBkColor(Cast(HDC, wParam),this.Color)
   		SetTextColor(Cast(HDC, wParam),this.TextColor) 
   		If this.b_Brush Then
   			DeleteObject(this.b_Brush)
   		EndIf
   		this.b_Brush = CreateSolidBrush(this.Color)
   		Function = Cast(LRESULT,this.b_Brush ) 	
	      Exit Function 
	                                  			
   	Case WM_CTLCOLORLISTBOX
			SetBkColor(Cast(HDC, wParam),this.Color)
   		SetTextColor(Cast(HDC, wParam),this.TextColor) 
   		If this.b_Brush Then
   			DeleteObject(this.b_Brush)
   		EndIf
   		this.b_Brush = CreateSolidBrush(this.Color)
   		Function = Cast(LRESULT,this.b_Brush ) 	
	      Exit Function  
	      
   	Case WM_COMMAND    		   	
		  	If HiWord(wParam) = CBN_SELCHANGE  Then
   			If this.onSelChange Then
   				item = SendMessage(this.Handle,CB_GETCURSEL,0,0)
   				If item  <> LB_ERR Then
   					SendMessage(this.Handle,CB_GETLBTEXT,item,CInt(@szItem))
   				EndIf
   				onSelChange(item,szItem)
   				SetFocus(this.Handle)	
   			EndIf
   			Function = 0
   			Exit Function
		  	End If
		
   End Select
   
   function = DefWindowProc( hWnd, uMsg, wParam, lParam)  
end Function

Sub FComboBox.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	      
     Dim AS ZString * 32 szClass
   DIM AS HINSTANCE hInst

   szClass     = "FB_CONTROL"
   hInst        = GetModuleHandle(0)


   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , x, y, w , h , _
                          hParent , NULL, hInst , NULL )

   SetWindowLong(this.CtHandle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz

   IF this.CtHandle  THEN
        this.Left    = x
        this.Top     = y
        this.Width   = w
        this.Height  = h
        this.Parent  = hParent
   ELSE
        MessageBox(0,"Fehler - Create COMBOBOX","Fehler",MB_ICONERROR)
        EXIT SUB
   END IF

   this.Handle = CreateWindowEx( this.ExStyle ,"COMBOBOX" ,NULL, this.Style  , 0, 0, w, h , this.CtHandle , NULL, hInst , NULL )
   IF this.Handle = 0 THEN
        MessageBox(0,"Fehler - Create COMBOBOX","Fehler",MB_ICONERROR)
   EndIf                                                 
End Sub
