'--------------------------------------------------------------------
' Image List 
'-------------------------------------------------------------------- 

Type FImageList Extends Object 
	
	Public:		    
   Declare Property Handle As HIMAGELIST
   Declare Property Width() As Integer							' Get  Width
   Declare Property Width( ByVal value As Integer )		' Set  Width
  	Declare Property Height() As Integer						' Get  Height
   Declare Property Height( ByVal value As Integer )		' Set  Height
   Declare Property Count  As Integer							' Get  Count
   
   Declare Constructor				
   Declare Destructor
   Declare Sub Create(ByVal IMGcount As Integer,ByVal x As Integer,ByVal y As Integer )					
	Declare Sub DrawImg(ByVal dc As HDC,ByVal index As Integer, ByVal zielX As Integer, ByVal zielY As Integer)
	Declare Sub AddBMP(sName As String)
	Declare Sub AddIcon(sName As String)
	Declare Sub AddIconHandle(ByVal hIcon As HICON )
	Declare Sub AddbmpHandle(ByVal hbmp As HBITMAP )
	Declare Sub DelItem( ByVal index As Integer)
   Declare sub Clear
	Private: 
  
	As HIMAGELIST	b_Handle	= 0
	As Integer	b_Width 		= 0
   As Integer	b_Height  	= 0
   As Integer  b_Count		= 0
	
End Type
Constructor	FImageList
	this.b_Width 		= 32
	this.b_Height  	= 32
	this.b_Count		= 1
	this.b_Handle		= 0
End Constructor
Destructor FImageList
	ImageList_Destroy(this.b_Handle)
	This.b_Handle = 0
End Destructor
Sub FImageList.Create(ByVal IMGcount As Integer,ByVal x As Integer,ByVal y As Integer )					

	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf

	this.b_Width 		= x
	this.b_Height  	= y
	this.b_Count		= IMGcount
	
	This.b_Handle = ImageList_Create(b_Width, b_Height, ILC_COLOR	, b_Count, 1)
	ImageList_SetBkColor(This.b_Handle,&HFFFFFF)
End Sub

Property FImageList.Handle As HIMAGELIST
	Return this.b_Handle
End Property
Property FImageList.Width() As Integer	
	Return this.b_Width
End Property
Property FImageList.Width( ByVal value As Integer )	
	this.b_Width = value
	ImageList_SetIconSize(this.b_Handle,this.b_Width,this.b_Height)
	' alle Images in der Liste werden gelscht !
End Property
Property FImageList.Height() As Integer					
	Return this.b_Height
End Property
Property FImageList.Height( ByVal value As Integer )		
	this.b_Height = value
	ImageList_SetIconSize(this.b_Handle,this.b_Width,this.b_Height)
	' alle Images in der Liste werden gelscht !
End Property
Property FImageList.Count  As Integer	
	this.b_Count = ImageList_GetImageCount(this.b_Handle)
	Return this.b_Count
End Property
Sub FImageList.AddBMP(sName As String)
	
	Dim As HINSTANCE hInst
   Dim As ZString * 128 szRes 
 	Dim As HBITMAP hBmp
 	
   hInst 	= GetModuleHandle(0)
   szRes		= sName
   
	If InStr(szRes,".") = 0 Then  	' Wenn kein Punkt (.) enthalen ist, dann Resource 
		hBmp	= LoadBitmap(hInst , cast( LPCSTR, @szRes ))	
		If hBmp  = 0 Then	Exit Sub			
	Else										' mit Punkt (.) dann Deteiname
   	hBmp		= LoadImage(NULL,@szRes,IMAGE_Bitmap,0,0,LR_DEFAULTCOLOR Or LR_LOADFROMFILE )
		If hBmp  = 0 Then	Exit Sub
   End If
	
	ImageList_Add(this.b_Handle,hBmp,NULL)
	
	If hBmp Then
		DeleteObject(hBmp)
	End If 
End Sub
Sub FImageList.AddIcon(sName As String)
	Dim As HINSTANCE hInst
   Dim As ZString * 128 szRes 
 	Dim As HICON hIco
 	
   hInst 	= GetModuleHandle(0)
   szRes		= sName
   
	If InStr(szRes,".") = 0 Then  	' Wenn kein Punkt (.) enthalen ist, dann Resource 
		hIco	= LoadIcon(hInst , cast( LPCSTR, @szRes ))	
		If hIco  = 0 Then Exit Sub
	Else										' mit Punkt (.) dann Deteiname
   	hIco	= LoadImage(NULL,@szRes,IMAGE_ICON,0,0,LR_DEFAULTCOLOR Or LR_LOADFROMFILE )
		If hIco  = 0 Then Exit Sub
   End If
	
	ImageList_AddIcon(this.b_Handle, hIco)
	
	If hIco Then
		DeleteObject(hIco)
	End If 
End Sub
Sub FImageList.AddIconHandle(ByVal hIcon As HICON )
		ImageList_AddIcon(this.b_Handle, hIcon)
End Sub
Sub FImageList.AddbmpHandle(ByVal hBmp As HBITMAP )
		ImageList_Add(this.b_Handle,hBmp,NULL)
End Sub
Sub FImageList.DelItem( ByVal index As Integer)
		ImageList_Remove(this.b_handle, index)
End Sub
Sub FImageList.Clear
		ImageList_Remove(this.b_handle, -1)
End Sub
Sub FImageList.DrawImg(ByVal dc As HDC,ByVal index As Integer, ByVal zielX As Integer, ByVal zielY As Integer)
		ImageList_Draw(this.b_Handle,index,dc,zielX,zielY,ILD_NORMAL) 
End Sub
