'--------------------------------------------------------------------
' Listbox
'-------------------------------------------------------------------- 
Type FListbox Extends Control	
	public:		    
   Declare Property GetSelString As String
   Declare Property GetSelItem As Integer
   Declare Property GetItemCount As Integer
   Declare Property Border(ByVal value As Integer)
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Sub SelItem(ByVal value As Integer)
   Declare Sub AddString(value As String) 
   Declare Sub Clear
   Declare Sub DelString(ByVal item As Integer)
	Declare Constructor
   Declare Destructor
   DECLARE  FUNCTION CtrlMsgFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT  
   ' Events	
	onDblClick As SUB( ByVal item As UInteger,szItem As ZString)	
	onSelChange As Sub(ByVal item As UInteger,szItem As ZString)
	Private: 	
   As HBRUSH	b_Brush		= 0
End Type
Constructor FListbox	
  	this.Handle  = 0
  	this.ExStyle = WS_EX_CLIENTEDGE
	this.Style 	 = WS_CHILD Or WS_VISIBLE  Or LBS_HASSTRINGS Or WS_TABSTOP Or LBS_NOINTEGRALHEIGHT Or LBS_NOTIFY Or WS_VSCROLL 
end Constructor
Destructor FListbox	
	If this.b_Brush Then
		DeleteObject(this.b_Brush)
	EndIf	
   this.Handle  = 0	
End Destructor
Property FListbox.GetSelString As String
	 If this.Handle Then
	 	Dim item As Integer
	 	Dim szItem As ZString * MAX_PATH
		item = SendMessage(this.Handle,LB_GETCURSEL,0,0)
	   If item  <> LB_ERR Then
	   	SendMessage(this.Handle,LB_GETTEXT,item,CInt(@szItem))
	   	Return szItem
	   Else
	   	szItem = ""
	   	Return szItem
	   EndIf
	 End If
End Property
Property FListbox.GetSelItem As Integer
	 If this.Handle Then
		return SendMessage(this.Handle,LB_GETCURSEL,0,0)
	 End If
End Property
Property FListbox.GetItemCount As Integer
	 If this.Handle Then
		return SendMessage(this.Handle,LB_GETCOUNT,0,0)
	 End If
End Property

Property FListbox.Border(ByVal value As Integer)
	If this.Handle Then		
		Select Case value
			Case 0				' Ohne
				this.Style 	= WS_CHILD Or WS_VISIBLE  Or LBS_HASSTRINGS Or WS_TABSTOP Or LBS_NOINTEGRALHEIGHT Or LBS_NOTIFY Or WS_VSCROLL 	
				this.ExStyle  = 0
			Case 1				' Sunken
				this.Style 	= WS_CHILD Or WS_VISIBLE  Or LBS_HASSTRINGS Or WS_TABSTOP Or LBS_NOINTEGRALHEIGHT Or LBS_NOTIFY Or WS_VSCROLL 
				this.ExStyle  = WS_EX_CLIENTEDGE
			Case 2				' Border
				this.Style 	= WS_CHILD Or WS_VISIBLE  Or LBS_HASSTRINGS Or WS_TABSTOP Or LBS_NOINTEGRALHEIGHT Or LBS_NOTIFY Or WS_VSCROLL Or WS_BORDER 
				this.ExStyle  = 0
		End Select
		SetWindowLong(this.Handle,GWL_STYLE,this.Style)
		SetWindowLong(this.Handle,GWL_EXSTYLE,this.ExStyle)
		SetWindowPos(this.Handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf	
End Property

Sub FListbox.AddString(value As String) 
	If this.Handle Then
		Dim  sItem As ZString * 128
		sItem = value
		SendMessage(this.Handle,LB_ADDSTRING,0,CInt(@sItem))
	EndIf
End Sub
Sub FListbox.SelItem(ByVal value As Integer) 
	If this.Handle Then
		SendMessage(this.Handle,LB_SETCURSEL ,value, 0 )	
		SetFocus(this.Handle)	
	EndIf
End Sub
Sub FListbox.Clear
	If this.Handle Then
		SendMessage(this.Handle, LB_RESETCONTENT ,0,0)
	EndIf
End Sub
Sub FListbox.DelString(ByVal item As Integer)
	If this.Handle Then
		SendMessage(this.Handle, LB_DELETESTRING ,item,0)
	EndIf
End Sub

Function FListbox.CtrlMsgFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
    
   Dim As UInteger item 
   Dim szItem As ZString * MAX_PATH 
   
   Select case uMsg 
   	CASE WM_ENABLE
         this.Enabled = wParam
         EXIT FUNCTION

   	Case WM_SETFONT,WM_SETTEXT
         IF this.Handle THEN
             FUNCTION = SendMessage(this.Handle,uMsg,wParam,lParam)
         END IF
         EXIT FUNCTION

   	Case WM_SIZE
         IF this.Handle THEN
             MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
         END IF
         EXIT FUNCTION
                                 			
   	Case WM_CTLCOLORLISTBOX
			SetBkColor(Cast(HDC, wParam),this.Color)
   		SetTextColor(Cast(HDC, wParam),this.TextColor) 
   		If this.b_Brush Then
   			DeleteObject(this.b_Brush)
   		EndIf
   		this.b_Brush = CreateSolidBrush(this.Color)
   		Function = Cast(LRESULT,this.b_Brush ) 	
	      Exit Function  
	     		
   	Case WM_COMMAND 
   	
   		If HiWord(wParam) = LBN_DBLCLK Then 
   			If this.onDblClick Then
   				item = SendMessage(this.Handle,LB_GETCURSEL,0,0)
   				If item  <> LB_ERR Then
   					SendMessage(this.Handle,LB_GETTEXT,item,CInt(@szItem))
   				EndIf
   				onDblClick(item,szItem)
   			End If
   			SetFocus(this.Handle)	
   			Function = 0
   			Exit Function
	   	End If
	   	
		  	If HiWord(wParam) = LBN_SELCHANGE  Then
   			If this.onSelChange Then
   				item = SendMessage(this.Handle,LB_GETCURSEL,0,0)
   				If item  <> LB_ERR Then
   					SendMessage(this.Handle,LB_GETTEXT, item,CInt(@szItem))
   				EndIf
   				onSelChange(item,szItem)
   			EndIf
   			Function = 0
   			Exit Function
		  	End If
		
   End Select
   FUNCTION = DefWindowProc(hWnd,uMsg,wParam,lParam)    
end Function

Sub FListbox.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	
   Dim AS ZString * 32 szClass
   DIM AS HINSTANCE hInst

   szClass     = "FB_CONTROL"
   hInst        = GetModuleHandle(0)



   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , x, y, w , h , _
                          hParent , NULL, hInst , NULL )

   SetWindowLong(this.CtHandle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz

   IF this.CtHandle  THEN
        this.Left    = x
        this.Top     = y
        this.Width   = w
        this.Height  = h
        this.Parent  = hParent
   ELSE
        MessageBox(0,"Fehler - Create LISTBOX","Fehler",MB_ICONERROR)
        EXIT SUB
   END IF

   this.Handle = CreateWindowEx( this.ExStyle ,"LISTBOX" ,NULL, this.Style  , 0, 0, w, h , this.CtHandle , NULL, hInst , NULL )
   IF this.Handle = 0 THEN
        MessageBox(0,"Fehler - Create LISTBOX","Fehler",MB_ICONERROR)
   EndIf                                                                   
End Sub
