'--------------------------------------------------------------------
'	FPanel 
'--------------------------------------------------------------------
Type FPanel Extends Control	
	public:
	Declare Property TextAlign(ByVal value as Integer) 
	Declare Property TextAlign as Integer
   Declare Property Border(ByVal value as Integer) 
   Declare Property Border As Integer 
   Declare Sub BKBmp( value as String)        
   Declare Sub Create(ByVal hParent As HWND,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor  
   ' Events	
	onLbuttondown As Sub(ByVal x As Integer,ByVal y As Integer,ByVal flag As Integer)
	onLbuttonup As Sub(ByVal x As Integer,ByVal y As Integer,ByVal flag As Integer)
	onMousemove As Sub(ByVal x As Integer,ByVal y As Integer,ByVal flag As Integer)
	onRbuttondown As Sub(ByVal x As Integer,ByVal y As Integer,ByVal flag As Integer)
	onPaint As Sub(ByVal dc As HDC)

   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Private: 
   As Integer  b_TextAlign	= 1
   As Integer	b_Border		= 0
   As HBITMAP 	b_Bmp			= 0
End Type
Constructor FPanel	
  	this.Handle  = 0
  	this.ExStyle = WS_EX_CONTROLPARENT	
	this.Style 	 = WS_CHILD Or WS_VISIBLE 
End Constructor

Destructor FPanel ' OK
	If this.b_Bmp Then
		DeleteObject(this.b_Bmp)
		this.b_Bmp = 0
	EndIf
   this.Handle  = 0
End Destructor

Property FPanel.TextAlign As Integer 
	Return this.b_TextAlign
End Property
Property FPanel.TextAlign(value as Integer) 
	If this.Handle Then
		Select Case value
			Case 0 	' links	einzeilig
				b_TextAlign = 0
			Case 1	' mitte einzeilig
				b_TextAlign = 1				
			Case 2	' rechts einzeilig
				b_TextAlign = 2	
			Case 3 	' links	mehrzeilig
				b_TextAlign = 3
			Case 4	' mitte  mehrzeilig
				b_TextAlign = 4				
			Case 5	' rechts mehrzeilig
				b_TextAlign = 5									
		End Select
	EndIf
End Property
Property FPanel.Border As Integer
	Return this.b_Border
End Property
Property FPanel.Border(value as Integer) 	
	If this.Handle Then
		Select Case value
			Case 0	' ohne		default
				b_Border = 0
			Case 1	' sunken
				b_Border = 1				
			Case 2	' raised
				b_Border = 2	
			Case 3	' rahmen
				b_Border = 3
			Case 4	' rahmen	
				b_Border = 4
		End Select
	EndIf
End Property

Sub FPanel.BKBmp( value as String)
	
	Dim As FBILoad Ptr bml
	bml = New FBILoad
	
	If InStr(value,".") = 0 Then  	' Resource 
		bml->LoadBitmapRes(value)
	Else										' Deteiname
		bml->LoadBitmapFile(value)
	End If
	If bml->bBitmap Then
		this.b_BMP = bml->CopyhBitmap
	End If
	Delete bml
End Sub

Function FPanel.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Function = 0 
   Dim As HDC hDc,dc
   Dim As RECT rc
   Dim As HBRUSH hBr  
   Dim As UInteger drStyle
	Dim As BITMAP bm
	
   Select case uMsg  
   	
   	Case WM_PAINT	
    		dim pnt as PAINTSTRUCT
         hDC = BeginPaint( hWnd, @pnt )
   	
         	GetClientRect(hWnd,@rc)
         	If this.b_Bmp = 0 Then
	 				'Hintergrund  Color ------------------
	         	SetBkColor(hDC,this.Color)
		   		hBr = CreateSolidBrush(this.Color)
		   		FillRect(hDC,@rc,hBr)
		   		DeleteObject(hBr)    
	   		Else
	   			'Hintergrund Bild ------------------ 
	   			dc = CreateCompatibleDC(hDC)
	   			SelectObject(dc,this.b_Bmp)
	   			GetObject(this.b_Bmp,SizeOf(bm),@bm)
	   			StretchBlt(hDC,rc.left,rc.top,rc.right,rc.bottom,dc,0,0,bm.bmWidth,bm.bmHeight,SRCCOPY)	
	   			DeleteDC(dc)
         	End If	    	
   			'Rahmen ------------------------------
   			If this.b_Border = 1 Then
         		DrawEdge(hDC,@rc, EDGE_SUNKEN , BF_RECT )
   			ElseIf this.b_Border = 2 Then
         		DrawEdge(hDC,@rc,  EDGE_RAISED , BF_RECT ) 
   			ElseIf this.b_Border = 3 Then
         		DrawEdge(hDC,@rc, EDGE_BUMP , BF_RECT )
   			ElseIf this.b_Border = 4 Then
   				hBr = CreateSolidBrush(&HAAAAAA)
   				FrameRect(hDC,@rc,hBr)
   				DeleteObject(hBr)
   			End If
   			
   			'Text --------------------------------
   			If Len(this.Caption) > 0 Then
	         	rc.left = rc.left + 2
	         	rc.Top = rc.Top + 2 	
	         	rc.right = rc.right - 2
	         	rc.bottom = rc.bottom - 2
	         	SetBkMode(hDc, TRANSPARENT)
	         	SetTextColor(hDC,this.TextColor)
	         	DeleteObject(SelectObject(hDc,this.Font))        	
	         	Select Case this.b_TextAlign
	         		Case 0
	         			drStyle = DT_SINGLELINE or DT_LEFT or DT_VCENTER
	         		Case 1
	         			drStyle = DT_SINGLELINE or DT_CENTER or DT_VCENTER
	         		Case 2
	         			drStyle = DT_SINGLELINE or DT_RIGHT	 or DT_VCENTER
	         		Case 3
	         			drStyle = DT_EDITCONTROL or DT_LEFT or DT_VCENTER Or DT_WORDBREAK	
	         		Case 4
	         			drStyle = DT_EDITCONTROL or DT_CENTER or DT_VCENTER Or DT_WORDBREAK	
	         		Case 5
	         			drStyle = DT_EDITCONTROL or DT_RIGHT or DT_VCENTER	Or DT_WORDBREAK	         	
	         	End Select
	   			DrawText(hDC,this.Caption, -1, @rc, drStyle )
   			End If
   			If this.onPaint Then
   				onPaint(hDc)
   			EndIf
   		EndPaint( hWnd, @pnt )
   		Function = 0
   		Exit Function
   		'------------------------- 	
   	Case WM_RBUTTONDOWN
   		If this.onRbuttondown Then
         	onRbuttondown(LOWORD(lParam),HIWORD(lParam),wParam)
   		End If	
    		Function = 0
   		Exit Function
   		'------------------------- 			
   	Case WM_LBUTTONDOWN
   		If this.onLbuttondown Then
         	onLbuttondown(LOWORD(lParam),HIWORD(lParam),wParam)
   		End If	
    		Function = 0
   		Exit Function
   		'------------------------- 
   	Case WM_LBUTTONUP 
   		If this.onLbuttonup Then
         	onLbuttonup(LOWORD(lParam),HIWORD(lParam),wParam)
   		End If	
			Function = 0
   		Exit Function
   		'------------------------- 
   	Case WM_MOUSEMOVE
   		If this.onMousemove Then
         	onMousemove(LOWORD(lParam),HIWORD(lParam),wParam) 
   		End If	 
   		Function = 0
   		Exit Function
   		'------------------------- 
   	
   End Select
   	
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
end Function

Sub FPanel.Create(ByVal hParent As HWND ,ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	        
   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst 
  	
 	
 	this.Parent = hParent
  	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
   
  
   this.Handle = CreateWindowEx( this.ExStyle  , @szClass , "" , this.Style  , x, y, w , h , _                    
                          this.Parent , NULL, hInst , NULL )
                                                   
   SetWindowLong(this.Handle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz                        
                                                                    
   If this.Handle  Then  
   	this.Left	 = x
		this.Top		 = y
   	this.Width 	 = w
  		this.Height  = h
   	this.Caption = ""   		   	
   Else
   	MessageBox(0,"Fehler - Create Panel","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
                                
End Sub
