'--------------------------------------------------------------------
' Horiz. Scollbar
'--------------------------------------------------------------------
Type FHScrollBar Extends Control		
	public: 	 
	Declare Property position (ByVal value As Integer)
   Declare Property position  As Integer  
   Declare Sub Range(ByVal min As Integer, ByVal max As Integer) 
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor  
   ' Events	
	onChange  As SUB(ByVal nPos As Integer ) 
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Private:
   As Integer  b_RangeMin	= 0
   As Integer  b_RangeMax	= 0
End Type

Constructor FHScrollBar	
  	this.Handle  = 0
  	this.ExStyle = 0	
	this.Style 	 =  WS_CHILD or SBS_HORZ Or WS_VISIBLE
end Constructor

Destructor FHScrollBar
   this.Handle  = 0
End Destructor

Property FHScrollBar.position (ByVal value As Integer)
	If this.Handle Then
		If (value >= this.b_RangeMin) And (value <= this.b_RangeMax) Then
			SendMessage(this.Handle,SBM_SETPOS ,value,TRUE) 
		End If
	End If
End Property

Property FHScrollBar.position  As Integer
	If this.Handle Then
		Return SendMessage(this.Handle,SBM_GETPOS ,0,0)
   End If
End Property

Sub FHScrollBar.Range(ByVal min As Integer, ByVal max As Integer)
	If this.Handle Then
		this.b_RangeMin = min
		this.b_RangeMax = max
		SetScrollRange(this.Handle,SB_CTL,min,max,TRUE)
	EndIf
End Sub


Function FHScrollbar.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Function = 0 
   
   Dim As HBRUSH hBr
   Dim As Integer nPos 
   
   Select case uMsg   	
    	Case WM_ENABLE 
   		this.Enabled = wParam
   		Exit Function
   		
   	Case WM_SIZE
   		If this.Handle Then
    			MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
   		End If
    		Exit Function 
    		
   				
   	Case WM_CTLCOLORSCROLLBAR 
			If hBr Then
				DeleteObject(hBr)
			EndIf
			hBr = CreateSolidBrush(this.Color)
  		  		Function = Cast(LRESULT, hBr )
  		  	Exit Function
  		  	 		
   	Case WM_HSCROLL 
  			Select Case LoWord(wParam)
  				Case SB_THUMBTRACK	
  					nPos = HIWORD(wParam)
  					SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					If this.onChange Then onChange(nPos)
  				Case SB_THUMBPOSITION	
  					nPos = HIWORD(wParam)
  					SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					If this.onChange Then onChange(nPos)
  				Case SB_BOTTOM
  					nPos = this.b_RangeMax
  					SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					If this.onChange Then onChange(nPos)
  				Case SB_LINEDOWN
  					nPos = GetScrollPos(this.Handle,SB_CTL) 
  					If nPos < this.b_RangeMax Then
  						nPos = nPos +  Int((this.b_RangeMax - this.b_RangeMin) / this.b_RangeMax)
  						SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					End If	
  					If this.onChange Then onChange(nPos)
  				Case SB_LINEUP
  					nPos = GetScrollPos(this.Handle,SB_CTL) 
  					If nPos > this.b_RangeMin Then
  						nPos = nPos -  Int((this.b_RangeMax - this.b_RangeMin) / this.b_RangeMax)
  						SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					End If	
  					If this.onChange Then onChange(nPos)
  				Case SB_TOP	
  					nPos = this.b_RangeMin
  					SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					If this.onChange Then onChange(nPos)
  			End Select
  			SetFocus(this.Handle)
  			Function = 0
  			Exit Function
  			
   	Case WM_VSCROLL 
  			Select Case LoWord(wParam)
  				Case SB_THUMBTRACK	
  					nPos = HIWORD(wParam)
  					SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					If this.onChange Then onChange(nPos)
  				Case SB_THUMBPOSITION	
  					nPos = HIWORD(wParam)
  					SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					If this.onChange Then onChange(nPos)
  				Case SB_BOTTOM
  					nPos = this.b_RangeMax
  					SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					If this.onChange Then onChange(nPos)
  				Case SB_LINEDOWN
  					nPos = GetScrollPos(this.Handle,SB_CTL) 
  					If nPos < this.b_RangeMax Then
  						nPos = nPos +  Int((this.b_RangeMax - this.b_RangeMin) / this.b_RangeMax)
  						SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					End If	
  					If this.onChange Then onChange(nPos)
  				Case SB_LINEUP
  					nPos = GetScrollPos(this.Handle,SB_CTL) 
  					If nPos > this.b_RangeMin Then
  						nPos = nPos -  Int((this.b_RangeMax - this.b_RangeMin) / this.b_RangeMax)
  						SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					End If	
  					If this.onChange Then onChange(nPos)
  				Case SB_TOP	
  					nPos = this.b_RangeMin
  					SetScrollPos(this.Handle,SB_CTL,nPos,TRUE)
  					If this.onChange Then onChange(nPos)
  			End Select
  			SetFocus(this.Handle)
  			Function = 0
  			Exit Function
   	
   End Select
  
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
end Function
'
Sub FHScrollbar.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )

   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
         
   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE Or WS_CHILD  , x, y, w , h , _                    
                          hParent , NULL, hInst , NULL )
                                                   
   SetWindowLong(this.CtHandle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz                        
                                                                    
   If this.CtHandle  Then  		
   	this.Left	 = x
		this.Top		 = y
   	this.Width 	 = w
  		this.Height  = h
   	this.Parent  = hParent  	
   Else
   	MessageBox(0,"Fehler - Create Button","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
                           
   this.Handle = CreateWindowEx( NULL ,  "SCROLLBAR"  , "", this.Style  ,  0, 0, w, h , this.CtHandle , NULL, hInst , NULL )                                            
   If this.Handle = 0 Then
   	MessageBox(0,"Fehler - Create Button","Fehler",MB_ICONERROR)
   EndIf  
End Sub
'---------------------------------------------------------------------------------------
' Vert. Scollbar
'---------------------------------------------------------------------------------------
Type FVScrollBar Extends FHScrollBar
   Declare Constructor
End Type

Constructor FVScrollBar
	this.Exstyle = 0
	this.style   = WS_CHILD or SBS_VERT Or WS_VISIBLE 
	this.Handle  = 0
End Constructor

