'--------------------------------------------------------------------
' Tab-Control
'-------------------------------------------------------------------- 

Type FTabControl Extends Control	
  	Public:
  	Declare Property UnSelTextColor() As UInteger						
   Declare Property UnSelTextColor( ByVal value As UInteger )
   Declare Property SelTabColor() As UInteger						
   Declare Property SelTabColor( ByVal value As UInteger )
   Declare Property UnSelTabColor() As UInteger						
   Declare Property UnSelTabColor( ByVal value As UInteger )
  	Declare Property TabHeight() As Integer						
   Declare Property TabHeight( ByVal value As Integer )
   Declare Property TabCount() As Integer						
   Declare Property TabCount( ByVal value As Integer )
   Declare Property CurTab As Integer 
   Declare Property CurTab( ByVal value As Integer )
   Declare Sub addTab(TabCaption As String,ByVal ImgIndex As Integer )
	Declare Sub SetImageList(ByVal hImgList As HIMAGELIST )
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor
   ' Events	
   onChange As SUB( ByVal tbPos As Integer)	
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
	Private:
	Declare Sub DrawItem(lpDraw As LPDRAWITEMSTRUCT )
	DECLARE static FUNCTION SubClassFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
	As UInteger b_BgColor = &HF8E8d8
	As UInteger b_UnBgColor = &HFFFFFF
   As Integer  b_TabIndex	= -1
	As ZString * 128 b_szTab
	As Integer  b_TabHight  = 26
	As UInteger b_UnSelTextColor = &H0
	As UInteger b_oldProc	= 0
End Type

Constructor FTabControl
	
	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf
	
	this.b_TabIndex = -1
	this.b_UnSelTextColor = &H0
	this.Handle = 0
	this.Style 	= WS_CHILD OR WS_VISIBLE OR WS_TABSTOP OR TCS_FOCUSONBUTTONDOWN  OR TCS_RIGHTJUSTIFY OR TCS_OWNERDRAWFIXED 'TCS_MULTILINE 
	this.ExStyle = WS_EX_LEFT OR WS_EX_LTRREADING  
	            
End Constructor

Destructor FTabControl
	If this.Handle Then
		SetWindowLong(this.Handle, GWL_WNDPROC, this.b_oldProc)
	End If
   this.Handle  = 0
End Destructor

Property FTabControl.UnSelTextColor() As UInteger	
	Return this.b_UnSelTextColor
End Property
Property FTabControl.UnSelTextColor( ByVal value As UInteger )
	this.b_UnSelTextColor = value
End Property
Property FTabControl.TabHeight() As Integer		
	Return this.b_TabHight-1
End Property
Property FTabControl.TabHeight( ByVal value As Integer )
	Dim As Integer cx,cy
	Dim As RECT rc
	 
	this.b_TabHight = value
	If this.Handle Then
		TabCtrl_GetItemRect(this.Handle,0,@rc)
		cx = rc.right
		cy = value
		TabCtrl_SetItemSize(this.Handle,cx,cy)
	EndIf
End Property

Property FTabControl.SelTabColor() As UInteger	
	Return this.b_BgColor
End Property
Property FTabControl.SelTabColor( ByVal value As UInteger )
	this.b_BgColor = value
End Property
Property FTabControl.UnSelTabColor() As UInteger	
	Return this.b_UnBgColor
End Property
Property FTabControl.UnSelTabColor( ByVal value As UInteger )
	this.b_UnBgColor = value
End Property
   
Property FTabControl.TabCount() As Integer 
	If this.Handle Then
		Return TabCtrl_GetItemCount(this.Handle)
	EndIf
End Property
Property FTabControl.TabCount( ByVal value As Integer ) 
 '
End Property
Property FTabControl.CurTab As Integer 
	If this.Handle Then
		Return TabCtrl_GetCurSel(this.Handle)
	EndIf
End Property
Property FTabControl.CurTab( ByVal value As Integer )
	Dim As Integer i
	If this.Handle Then
		i = TabCtrl_GetItemCount(this.Handle)
		If (value >=0) And (value < i) Then
			If value <> TabCtrl_GetCurSel(This.Handle) Then
				If this.onChange Then this.onChange(value)
			EndIf
			TabCtrl_SetCurSel(this.Handle,value)
		EndIf	
	EndIf
End Property
Sub FTabControl.DrawItem(lpdis As LPDRAWITEMSTRUCT ) 
	
	Dim As BOOL bSel
	Dim hBr As HBRUSH
	Dim As TC_ITEM ti
	Dim As RECT rc
	Dim As HIMAGELIST hImg
	Dim As IMAGEINFO imgInfo 
	Dim As Integer x,y
	
	if (lpdis->itemID < 0) Or (lpdis->itemID > this.TabCount - 1) Then 
		Exit Sub
	EndIf
	
	If lpdis->itemID = TabCtrl_GetCurSel(this.Handle) Then
		bSel = TRUE
	Else
		bSel = FALSE
	EndIf
	
	CopyRect(@rc,@lpdis->rcItem)
	
	' Hintergrund 
	If bSel Then
		hBr = CreateSolidBrush(this.b_BgColor)
	Else
		hBr = CreateSolidBrush(this.b_UnBgColor)
	EndIf		
		FillRect(lpdis->hDC,@rc,hBr)
		DeleteObject(hBr)
		
		' TextFarbe	
		SetBkMode(lpdis->hDC,TRANSPARENT)
	If bSel Then	
		SetTextColor(lpdis->hDC,this.TextColor)
	Else	
		SetTextColor(lpdis->hDC,this.b_UnSelTextColor)
	EndIf
	
		' Text schreiben
		ti.mask = TCIF_TEXT Or TCIF_IMAGE
		ti.pszText = @b_szTab
		ti.cchTextMax = SIZEOF(b_szTab)
		TabCtrl_GetItem(lpdis->hwndItem, lpdis->itemID, @ti)
	
	hImg = Cast(HANDLE, SendMessage(this.Handle, TCM_GETIMAGELIST ,0,0)) 	
	If (hImg <> 0) And (ti.iImage <> -1) Then 		
		ImageList_GetImageInfo(hImg, lpdis->itemID , @imgInfo)
		TabCtrl_GetItemRect(this.Handle,lpdis->itemID,@rc)

		y = Int((rc.bottom - imgInfo.rcImage.bottom) / 2)
		x = rc.Left + 4
		
		ImageList_Draw(hImg, ti.iImage , lpdis->hDC, x ,y ,ILD_NORMAL)	
			
		CopyRect(@rc,@lpdis->rcItem)
		rc.left = rc.left + (imgInfo.rcImage.right-imgInfo.rcImage.left)			
		DrawText( lpdis->hDC, @b_szTab , -1, @rc , DT_SINGLELINE or DT_CENTER or DT_VCENTER )		
	Else
   	DrawText( lpdis->hDC, @b_szTab , -1, @lpdis->rcItem , DT_SINGLELINE or DT_CENTER or DT_VCENTER )	
	EndIf
		
End Sub
Sub FTabControl.addTab(TabCaption As String,ByVal ImgIndex As Integer )
	
	Dim As TC_ITEM ti
	Dim As RECT rc
	
	b_szTab = TabCaption
	
	ti.mask = TCIF_TEXT Or TCIF_IMAGE
	ti.iImage = ImgIndex
   ti.pszText =@b_szTab
   b_TabIndex = b_TabIndex + 1

   If this.handle Then 
   	If TabCtrl_InsertItem(this.handle, b_TabIndex, @ti ) = -1 Then 
            DestroyWindow(this.handle) 
            Exit sub
   	End If 
   	If TabCtrl_GetItemRect(this.handle, b_TabIndex,@rc) Then
	  		this.b_TabHight  = rc.bottom + 3
   	EndIf
		
   End If	
End Sub
Sub FTabControl.SetImageList(ByVal hImgList As HIMAGELIST )	
	TabCtrl_SetImageList(this.Handle,hImgList)	
End Sub
FUNCTION FTabControl.SubClassFunc(hWnd AS HWND,uMsg AS UINT,wParam AS wParam,lParam AS lParam) AS LRESULT 
		
	Dim as FTabControl ptr FTab = cast(FTabControl Ptr,GetWindowLong(hWnd,GWL_USERDATA)) ' Zeiger auf diese Klasse
	
	If FTab = 0 Then
		function = DefWindowProc(  hWnd, uMsg, wParam, lParam) 
		Exit Function
	EndIf
	
	Dim As HBRUSH hBr
	Dim As RECT rc
	
	Select case uMsg 
		
		Case WM_ERASEBKGND
			hBr = CreateSolidBrush(FTab->Color)
			GetClientRect(hWnd,@rc)
			FillRect(Cast(HDC, wParam),@rc,hBr)
			DeleteObject(hBr)
			Function = 1
			Exit Function
	End Select
	
	function = CallWindowProc( Cast(Any Ptr,FTab->b_oldProc), hWnd, uMsg, wParam, lParam) 
	
End Function

Function FTabControl.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT 
	
 	Dim As Integer iNr
 	
  	Select Case uMsg
  		CASE WM_ENABLE
         this.Enabled = wParam
         EXIT FUNCTION

  		Case WM_SETFONT,WM_SETTEXT
         IF this.Handle THEN
             FUNCTION = SendMessage(this.Handle,uMsg,wParam,lParam)
         END IF
         EXIT Function
     
  		CASE WM_SIZE
         IF this.Handle Then
            MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)            
         END IF
         EXIT FUNCTION 
         
  		CASE WM_PAINT
         dim pnt as PAINTSTRUCT
         Dim As RECT rc
         Dim As HBRUSH hBr
         Dim As HDC hDC
         hDC = BeginPaint( hWnd, @pnt )
         	GetClientRect(hWnd,@rc)
		   	hBr = CreateSolidBrush(this.Color)
		   	FillRect(hDC,@rc,hBr)
		   	DeleteObject(hBr) 
		   EndPaint( hWnd, @pnt )
   		Function = 0		   
         EXIT FUNCTION  
                          
  		Case WM_DRAWITEM
			Dim As LPDRAWITEMSTRUCT lpdis = Cast(Any Ptr, lParam)
			DrawItem(lpdis )
   		Function = TRUE
   		Exit Function
   		'-------------------------    				  		
  		Case WM_NOTIFY	
			Dim pNMSC AS NMHDR Ptr = Cast(Any Ptr, lParam)  	 		
  			Select Case pNMSC->code 
  				Case TCN_SELCHANGE
  					iNr = TabCtrl_GetCurSel(pNMSC->hwndFrom)
  					If this.onChange Then this.onChange(iNr)
  			End select		
  			Function = 0
   		Exit Function			
  		
  	End Select
   
    Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
End Function

Sub FTabControl.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )

    Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
         
   this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE Or WS_CHILD  , x, y, w , h , _                    
                          hParent , NULL, hInst , NULL )
                                                   
                                                                    
   If this.CtHandle  Then  
   	SetWindowLong(this.CtHandle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz                        
   	
   	this.Left	 = x
		this.Top		 = y
   	this.Width 	 = w
  		this.Height  = h
   	this.Parent  = hParent  	
   Else
   	MessageBox(0,"Fehler - TabControl Container","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
                          
   this.Handle = CreateWindowEx(0 , WC_TABCONTROL , "", this.Style  ,  0, 0, w, h , this.CtHandle , NULL, hInst , NULL )                                            
   If this.Handle = 0 Then
   	MessageBox(0,"Fehler - Create TabControl ","Fehler",MB_ICONERROR)
   	Exit Sub
   EndIf 
   
	this.b_oldProc = SetWindowLong( this.Handle, GWL_WNDPROC, CInt(@FTabControl.SubClassFunc))
	SetWindowLong(this.Handle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz
	
   TabCtrl_SetPadding(this.Handle,5,5)

End Sub
