'------------------------------------------------------------
' Hilfs Class fr Mouseverfolgung
'------------------------------------------------------------
Type MTrackEvents Extends Object
	public:
      Declare Sub myMouseMove(ByVal hWind As HWND)
      Declare Sub myReset
      Declare Constructor
   private:
      As BOOL m_bMouseTracking       
End Type

Constructor MTrackEvents
	m_bMouseTracking = FALSE
End Constructor

Sub MTrackEvents.myMouseMove(ByVal hWind As HWND)
	
	 if m_bMouseTracking = FALSE Then
      
      Dim as TRACKMOUSEEVENT tme
      
      tme.cbSize = sizeof(tme)
      tme.hwndTrack = hWind
      tme.dwFlags = TME_HOVER OR TME_LEAVE
      tme.dwHoverTime = HOVER_DEFAULT
      TrackMouseEvent(@tme)
      m_bMouseTracking = TRUE
	 End If
	 
End Sub
Sub MTrackEvents.myReset
	m_bMouseTracking = FALSE
End Sub

'--------------------------------------------------------------------------------------
'	FToolBtn
'--------------------------------------------------------------------------------------
Type FToolBtn Extends Control	
	public:
	Declare Property Border(Byval value as Integer)
	Declare Property Border as Integer
	Declare Property BorderColor(Byval value as UInteger)
	Declare Property BorderColor as UInteger
	Declare Property Down(Byval value as Integer)
	Declare Property Down as Integer
	Declare Property TextPos(Byval value as Integer)
	Declare Property TextPos as Integer
	Declare Property Focused(Byval value as Integer) ' Zeichnet Focusrect ja/nein
	Declare Property Focused as Integer
   Declare Sub Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer)
   Declare Sub LoadBmp( value as String)
   Declare Sub Image( value as String)
   Declare Constructor
   Declare Destructor 
   As MTrackEvents tEvents  
   ' Events		
	onClick As Sub
	onRbuttondown As Sub
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Private:
   b_Bitmap 	As BOOL
   b_dc			As HDC 
   b_TextPos 	As Integer
   b_bmWidth 	As Integer
   b_bmHeight 	As Integer
   b_Down		As Integer
   b_Focused	As Integer
   b_Border		As Integer
   b_ColBorder	As UInteger
End Type
Constructor FToolBtn	
	this.b_Bitmap 	= 0
	this.b_dc		= 0
   this.b_bmWidth = 0
   this.b_bmHeight = 0
  	this.Handle  	= 0
  	this.ExStyle 	= 0 	
	this.Style 	 	=  WS_CHILD Or WS_VISIBLE Or WS_TABSTOP
	this.b_Down		= FALSE
	this.b_Focused = FALSE
	this.b_TextPos = TRUE
	this.b_Border  = FALSE
	this.b_ColBorder  = &HAAAAAA
End Constructor

Destructor FToolBtn 
	If this.b_dc Then
		DeleteDC(this.b_dc)
	EndIf
   this.Handle  = 0  
End Destructor
Property FToolBtn.BorderColor(Byval value as UInteger)
	this.b_ColBorder = value
End Property
Property FToolBtn.BorderColor as UInteger
	Return this.b_ColBorder
End Property
Property FToolBtn.Border(Byval value as Integer)
		this.b_Border = IIf(value,TRUE,FALSE)
End Property
Property FToolBtn.Border as Integer
	Return this.b_Border
End Property
Property FToolBtn.TextPos(Byval value as Integer)
	this.b_TextPos = value
End Property
Property FToolBtn.TextPos as Integer
	Return this.b_TextPos
End Property
Property FToolBtn.Down(Byval value as Integer)
	this.b_Down = IIf(value,TRUE,FALSE)
	Invalidate
End Property
Property FToolBtn.Down as Integer
	Return this.b_Down 
End Property
Property FToolBtn.Focused(Byval value as Integer)
	this.b_Focused = IIf(value,TRUE,FALSE)
End Property
Property FToolBtn.Focused as Integer
	Return this.b_Focused
End Property

Sub FToolBtn.LoadBmp( value as String)
	
		Dim As HDC hDC	
		
		this.b_Bitmap = FALSE
			
		Dim As FBILoad Ptr bml
   	bml = New FBILoad
   	   	
	   If InStr(value,".") = 0 Then  	' Resource 
			bml->LoadBitmapRes( value)
	   Else										' Deteiname
	   	bml->LoadBitmapFile(value)
	   End If
	  
	   this.b_bmWidth 	= bml->bWidth
	   this.b_bmHeight  	= bml->bHeight 
	  	    
	   If bml->bBitmap Then
	 		this.b_Bitmap = TRUE
	 	Else
	 		 Delete bml	
	 		 Exit Sub
	   EndIf	
		
		If this.b_dc <> 0 Then
  			DeleteDC(this.b_dc)
		End If	
   	
	   hDC 		= GetDC(GetDesktopWindow)						
   	this.b_dc	= CreateCompatibleDC(hDC)
		SelectObject(this.b_dc,bml->bBitmap)

		ReleaseDC(GetDesktopWindow,hDC)
	   Delete bml		
End Sub

Sub FToolBtn.Image( value as String) ' kann JPG,PNG,GIF,TIFF und Bitmap laden
	
	this.b_Bitmap = FALSE	' wenn Fehler - wird nur Text gezeichnet
	
	If isFileExist(value) = FALSE Then
		MessageBox(0,"Image Datei nicht gefunden","Fehler",MB_ICONERROR)
		Exit sub
	EndIf
		
	Dim As ushort r,g,b
	
	r = GetRValue(this.Color)
	g = GetGValue(this.Color)
	b = GetBValue(this.Color)
	
	Dim As HBITMAP hBmp
	Dim As FImage Ptr img
	img = New FImage			' FImage Object
	
	img->bkColor 		= RGBA(r,g,b,255)
	img->LoadImg(value)
	
	this.b_bmWidth 	= img->ImgWidth 
	this.b_bmHeight  	= img->ImgHeight 
					
   this.b_dc	= CreateCompatibleDC(img->DC)
   hBmp = CreateCompatibleBitmap(img->DC,img->ImgWidth ,img->ImgHeight)
	SelectObject(this.b_dc,hBmp)
	DeleteObject(hBmp)
	
	If this.b_dc Then
		img->ImgCopy(this.b_dc, 0, 0 )
		this.b_Bitmap = TRUE	 ' kein Fehler - Bild wird (oder mit Text) gezeichnet
	Else
		MessageBox(0," ToolBtn ImageLoad Temp.HDC Fehler ","Fehler",MB_ICONERROR)
	EndIf
	
	Delete img
		
End Sub
Function FToolBtn.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT
   Function = 0 
   Dim As HDC hDC,tmpdc
   Dim As RECT rc,bmpRC
   Dim As HBRUSH hBr
 
   Select case uMsg  
   	Case WM_SETFOCUS 
   		Invalidate
			Exit Function
			'------------------------- 
   	Case WM_KILLFOCUS
   		Invalidate
   		Exit Function
   		'------------------------- 
   	Case WM_PAINT	
    		dim pnt as PAINTSTRUCT
    		Dim As Integer x,y
    		
         hDC = BeginPaint( hWnd, @pnt )
         GetClientRect(hWnd,@rc)
         
         'Hintergrund -------------------------
      	SetBkColor(hDC,this.Color)
   		hBr = CreateSolidBrush(this.Color)
   		FillRect(hDC,@rc,hBr)
   		DeleteObject(hBr) 
   		
   		If this.b_Border Then
   			hBr = CreateSolidBrush(this.b_ColBorder)
   			FrameRect(hDC,@rc,hBr)
   			DeleteObject(hBr)
   		EndIf
		'
   		If this.b_Down = TRUE Then
	   			DrawEdge(hDC,@rc, EDGE_SUNKEN	, BF_RECT )
	   	EndIf	
   		
   		If (this.b_Bitmap<>0) And (Len(this.Caption) = 0) Then 	' Nur Bild
   			x = Int((this.Width - this.b_bmWidth)/2)
				y = Int((this.Height - this.b_bmHeight)/2)
	   		
				BitBlt(hDC,x,y ,this.b_bmWidth + x,this.b_bmHeight + y ,this.b_dc,0,0,SRCCOPY)	
				
   		ElseIf (this.b_Bitmap=0) And (Len(this.Caption)<> 0) Then	' Nur Text
   			SetBkMode(hDc, TRANSPARENT)
         	SetTextColor(hDC,this.TextColor)
   			DeleteObject(SelectObject(hDc,this.Font)) 
   			DrawText(hDC,this.Caption, -1, @rc, DT_SINGLELINE or DT_CENTER or DT_VCENTER )
   		ElseIf (this.b_Bitmap<>0) And (Len(this.Caption)<> 0) Then	'  Bild + Text
   			If b_TextPos = TRUE Then	' Bild oben
		   		bmpRC.left 	= Int((rc.right - this.b_bmWidth) /2)
		   		bmpRC.top  	= rc.top + 5 ' Padding oben
		   		bmpRC.right	= this.b_bmWidth
		   		bmpRC.bottom= this.b_bmHeight	
		   		    	
	         	rc.left = rc.left + 2
	         	rc.Top = this.b_bmHeight + 10 
	   		Else							' Bild links
         		bmpRC.left 	= 5
		   		bmpRC.top  	= Int((rc.bottom - this.b_bmHeight) /2)
		   		bmpRC.right	= this.b_bmWidth
		   		bmpRC.bottom= this.b_bmHeight
		   		    	
	         	rc.left = rc.left + 5 + this.b_bmWidth
	         	
   			EndIf	
   			
         	BitBlt(hDC,bmpRC.left,bmpRC.top,bmpRC.right,bmpRC.bottom,this.b_dc,0,0,SRCCOPY)	
	   
         	SetBkMode(hDc, TRANSPARENT)
         	SetTextColor(hDC,this.TextColor)
         	DeleteObject(SelectObject(hDc,this.Font))        	
         	
   			DrawText(hDC,this.Caption, -1, @rc, DT_SINGLELINE or DT_CENTER or DT_VCENTER )	
   		EndIf 
   		
   		' FocusRect zeichnen
   		If (hWnd = GetFocus()) And (this.b_Focused = TRUE)Then
	   		GetClientRect(hWnd,@rc)
	   		rc.left +=3 
	   		rc.top +=3
	   		rc.right -=3
	   		rc.bottom -=3
	   		DrawFocusRect(hDc,@rc) 	
   		End If	
   		
   		EndPaint( hWnd, @pnt )
   		Exit Function
   		'------------------------- 	
   	Case WM_RBUTTONDOWN
   		If this.onRbuttondown Then
         	onRbuttondown()
   		End If	
   		Exit Function
   		'------------------------- 			
   	Case WM_LBUTTONDOWN
   		If this.b_Down = FALSE Then
	   		hDc = GetDC(hWnd)
	   		GetClientRect(hWnd,@rc)
	   		DrawEdge(hDC,@rc, EDGE_SUNKEN	, BF_RECT ) 	
	   		ReleaseDC(hWnd,hDc)
	   	Else
	   		this.Down = FALSE
   		End If
   		Exit Function
   		'------------------------- 
   	Case WM_LBUTTONUP 
   		If this.onClick Then
         	onClick()
   		End If
   		SetFocus(hWnd)
   		Invalidate
   		Exit Function
   		'------------------------- 
   	Case WM_MOUSEMOVE
   		If this.b_Down = FALSE Then
	   		hDc = GetDC(hWnd)
	   		GetClientRect(hWnd,@rc)
	   		DrawEdge(hDC,@rc, EDGE_RAISED	, BF_RECT ) 	
	   		ReleaseDC(hWnd,hDc)
   		End If	
   		tEvents.myMouseMove(hWnd)
   		Exit Function
   		'------------------------- 
   		
   	case WM_MOUSELEAVE
			Invalidate
   		tEvents.myReset 
   		Exit Function
   		
   	case WM_MOUSEHOVER  		
   		tEvents.myReset 
   		Exit Function
   		
   	Case WM_KEYDOWN 
   		If  wParam = 32 Then
		   		hDc = GetDC(hWnd)
		   		GetClientRect(hWnd,@rc)
		   		DrawEdge(hDC,@rc, EDGE_SUNKEN	, BF_RECT ) 	
		   		ReleaseDC(hWnd,hDc)
   		End If	
   		Exit Function
   		'------------------------- 
   	Case WM_KEYUP
   		If  wParam = 32 Then
		   		GetClientRect(hWnd,@rc)
		   		If this.onClick Then
		         	onClick()
		   		End If
		   		SetFocus(hWnd)
		   		InvalidateRect(hWnd,@rc,TRUE)
   		End If	
   		Exit Function
   End Select
   	
 
   Function = DefWindowProc(hWnd,uMsg,wParam,lParam)
end Function

Sub FToolBtn.Create(ByVal hParent As HWND, ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer)
	        
   Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst 
  	
 	
 	this.Parent = hParent
  	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
   
  
   this.Handle = CreateWindowEx( this.ExStyle  , @szClass , "" , this.Style  , x, y, w , h , _                    
                          this.Parent , NULL, hInst , NULL )
                                                   
   SetWindowLong(this.Handle ,GWL_USERDATA,CInt(@This)) ' Zeiger diese Instanz                        
                                                                    
   If this.Handle  Then  
   	this.Left	 = x
		this.Top		 = y
   	this.Width 	 = w
  		this.Height  = h
   	this.Caption = ""   		   	
   Else
   	MessageBox(0,"Fehler - Create FToolBtn","Fehler",MB_ICONERROR)
   	Exit Sub
   End If
                                
End Sub
