
'--------------------------------------------------------------------
' Trackbar
'-------------------------------------------------------------------- 
Type FTrackbar Extends Control
	
	public:		    
   Declare Property TumpColor(ByVal value As UInteger)
   Declare Property TumpColor As UInteger 
   Declare Property RilColor(ByVal value As UInteger)
   Declare Property RilColor As UInteger 
   Declare Property DefTump(ByVal value As Integer)
   Declare Property DefTump As Integer 
   Declare Property Tick(ByVal value As Integer)
   Declare Property Tick As Integer 
   Declare Property TumpPos(ByVal value As Integer)
   Declare Property TumpPos As Integer 
	Declare Property Border(ByVal value As Integer)
   Declare Property Border As Integer 
   Declare Property Orientation(ByVal value As Integer) ' vordefiniert = Horizontal ;  Orientation = 1 Vertical
   Declare Property Orientation As Integer 
   Declare sub Range(ByVal min As  USHORT ,ByVal max As  USHORT )
   Declare Sub Create(ByVal hParent As HWND,  ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
   Declare Constructor
   Declare Destructor

   ' Events	
   onChange As SUB( ByVal tbPos As Integer)	
   
   Declare  Function CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT  
	Private:   
	As Integer  b_Orient		= 0	' horizontal
	As Integer  b_Border		= 0
	As HBRUSH	b_Brush		= 0
	As UInteger b_TumpColor	= &HBBBBBB
	As UInteger b_RilColor	= &HEEEEEE
	As Integer  b_DefTump	= FALSE
	As Integer  b_Tick		= TRUE
End Type

Constructor FTrackbar
	
	If InitCommon = 0 Then 
		InitCommonControls
		InitCommon = 1
	EndIf	
	this.Handle = 0
	this.Style 	= WS_CHILD or WS_VISIBLE or TBS_TOOLTIPS  Or TBS_FIXEDLENGTH OR  TBS_AUTOTICKS 
	'this.Style 	= WS_CHILD or WS_VISIBLE or TBS_TOOLTIPS  Or TBS_ENABLESELRANGE OR  TBS_AUTOTICKS ' breite Rille
End Constructor 

Destructor FTrackbar
	If this.b_Brush Then
		DeleteObject(this.b_Brush)
   EndIf
   this.Handle  = 0
End Destructor

Property FTrackbar.TumpPos(ByVal value As Integer)
	Dim As Integer nMin,nMax
	If this.Handle Then
		nMin = SendMessage(this.Handle, TBM_GETRANGEMIN , 0 , 0)
		nMax = SendMessage(this.Handle, TBM_GETRANGEMAX , 0 , 0)
		If (value <= nMax) And (value >= nMin) Then
			SendMessage(this.Handle, TBM_SETPOS, TRUE , value)
		EndIf
	EndIf
End Property
Property FTrackbar.TumpPos As Integer 
	If this.Handle Then
		Return SendMessage(this.Handle, TBM_GETPOS, 0, 0)
	EndIf
End Property
Property FTrackbar.TumpColor(ByVal value As UInteger)
	If this.Handle Then
		this.b_TumpColor = value
		Repaint
	EndIf
End Property
Property FTrackbar.TumpColor As UInteger 
	Return this.b_TumpColor
End Property
Property FTrackbar.RilColor(ByVal value As UInteger)
	If this.Handle Then
		this.b_RilColor = value
		Repaint
	EndIf
End Property
Property FTrackbar.RilColor As UInteger 
	Return this.b_RilColor
End Property
Property FTrackbar.DefTump(ByVal value As Integer)
	If this.Handle Then
		this.b_DefTump = IIf(value,TRUE,FALSE)
	EndIf
End Property
Property FTrackbar.DefTump As Integer 
	Return this.b_DefTump
End Property
Property FTrackbar.Tick(ByVal value As Integer)
	If this.Handle Then
		If value Then
			this.Style 	= WS_CHILD or WS_VISIBLE or TBS_TOOLTIPS  Or TBS_FIXEDLENGTH OR  TBS_AUTOTICKS Or this.b_Orient  
		Else
			this.Style 	= WS_CHILD or WS_VISIBLE or TBS_TOOLTIPS  Or TBS_FIXEDLENGTH OR TBS_NOTICKS Or this.b_Orient 
		EndIf
		SetWindowLong(this.handle,GWL_STYLE,this.Style)
		Repaint
	EndIf
End Property
Property FTrackbar.Tick As Integer 
	Return this.b_Tick
End Property

Property FTrackbar.Orientation(ByVal value As Integer)
	If this.Handle Then
		Dim  As UInteger styl = GetWindowLong(this.handle,GWL_STYLE)
		If value Then
			this.b_Orient = TBS_VERT 			' <> 0 TBS_VERT 
			styl = styl And (Not TBS_HORZ)
			styl = styl Or TBS_VERT
		Else
			this.b_Orient = TBS_HORZ			' 0 = TBS_HORZ
			styl = styl And (Not TBS_VERT )
			styl = styl Or TBS_HORZ
		EndIf	
		this.Style = styl
		SetWindowLong(this.handle,GWL_STYLE,this.Style)
		Repaint
	EndIf
End Property
Property FTrackbar.Orientation As Integer 
	Return this.b_Orient
End Property
Property FTrackbar.Border(ByVal value As Integer)
	If this.Handle Then
		this.b_Border = value
		Select Case value
			Case 0
				this.Style = WS_CHILD or WS_VISIBLE or TBS_AUTOTICKS Or TBS_FIXEDLENGTH Or this.b_Orient 
				this.ExStyle = 0
			Case 1
				this.Style = WS_CHILD or WS_VISIBLE or TBS_AUTOTICKS Or TBS_FIXEDLENGTH Or WS_BORDER Or this.b_Orient
				this.ExStyle = 0
			Case 2
				this.Style = WS_CHILD or WS_VISIBLE or TBS_AUTOTICKS Or TBS_FIXEDLENGTH Or this.b_Orient
				this.ExStyle = WS_EX_CLIENTEDGE 
		End Select
			SetWindowLong(this.handle,GWL_STYLE,this.Style)
			SetWindowLong(this.handle,GWL_EXSTYLE,this.ExStyle)
			SetWindowPos(this.handle,0,0,0,this.Width,this.Height,SWP_DRAWFRAME Or SWP_FRAMECHANGED)
	EndIf
End Property
Property FTrackbar.Border As Integer 
	Return this.b_Border
End Property

Function FTrackbar.CtrlMsgFunc(hWnd As HWND,uMsg as UINT,wParam as wParam,lParam as lParam) as LRESULT  
	
   Dim As Integer nPos
 	Dim As HBRUSH hBrush
 	
  	Select Case uMsg
  		
  		CASE WM_ENABLE
         this.Enabled = wParam
         EXIT Function

   	Case WM_SIZE
         IF this.Handle THEN
             MoveWindow(this.Handle,0,0,LOWORD(lParam),HiWord(lParam),TRUE)
         END IF
         EXIT Function
      
  		Case WM_NOTIFY
  			Dim As NMCUSTOMDRAW Ptr pNMCD = Cast(Any Ptr, LPARAM)   		
   		If pNMCD->hdr.hwndFrom = this.Handle THEN    
   			If pNMCD->hdr.code = NM_CUSTOMDRAW THEN 
    			Select CASE pNMCD->dwDrawStage
    				Case CDDS_PREPAINT
    					' Wenn hier NULL zurckgegeben wird kommen keine weiteren PREPAINT Messagen
        				Function = CDRF_NOTIFYITEMDRAW 	'CDRF_NOTIFYITEMDRAW OR CDRF_NOTIFYPOSTPAINT		
        				Exit FUNCTION 
    				case CDDS_PREERASE , CDDS_POSTERASE ,CDDS_ITEMPREERASE, CDDS_ITEMPOSTERASE
    					Function = CDRF_DODEFAULT	
        				Exit FUNCTION 
        				
    				case CDDS_ITEMPREPAINT
    					Select Case pNMCD->dwItemSpec
    						Case TBCD_CHANNEL
         					DrawEdge(pNMCD->hdc, @pNMCD->rc, EDGE_SUNKEN , BF_RECT ) ' Rnder der Rille
         					InflateRect( @pNMCD->rc, -1, -1 )  
         					hBrush = CreateSolidBrush(this.b_RilColor) ' color der Rille
         					FillRect(pNMCD->hdc, @pNMCD->rc, hBrush )  ' Rille fllen
         					DeleteObject hBrush
         					Function = CDRF_SKIPDEFAULT    				 'fertig keine weiteren Zeichnungen
    							' wen weiter Zeichnung dann Function = CDRF_DODEFAULT Or CDRF_NOTIFYPOSTPAINT
    							Exit Function
    						case TBCD_TICS	
    							Function =  CDRF_DODEFAULT						 'fertig keine weiteren Zeichnungen
    							Exit Function
    						case TBCD_THUMB
    							If this.b_DefTump Then
    								Function =  CDRF_DODEFAULT					 'fertig keine weiteren Zeichnungen
    								Exit Function
    							Else	
    								hBrush = CreateSolidBrush(b_TumpColor) 
         						FillRect(pNMCD->hdc, @pNMCD->rc, hBrush )  
         						DeleteObject hBrush
         						DrawEdge(pNMCD->hdc, @pNMCD->rc, BDR_RAISEDOUTER , BF_RECT )
         						Function = CDRF_SKIPDEFAULT				'fertig keine weiteren Zeichnungen
    								Exit Function
    							End if	
    					End Select
    			End Select
   			EndIf
   		EndIf	
   		
       
  		Case WM_CTLCOLORSTATIC 
			If this.b_Brush Then
				DeleteObject(this.b_Brush)
			EndIf
  		  	this.b_Brush = CreateSolidBrush(This.Color)
  		  	Function = Cast(LRESULT,this.b_Brush)
  		  	Exit Function
  		  	
  		Case WM_HSCROLL 
  			Select Case LoWord(wParam)  				
  				Case SB_THUMBTRACK
  					If this.onChange Then this.onChange(HIWORD(wParam))	
  				Case SB_BOTTOM, SB_LINEDOWN, SB_LINEUP, SB_TOP
  					nPos = SendMessage(this.Handle, TBM_GETPOS, 0, 0)
  					If this.onChange Then this.onChange(nPos)
  				Case SB_ENDSCROLL
  					nPos = SendMessage(this.Handle, TBM_GETPOS, 0, 0)
  					If this.onChange Then this.onChange(nPos)
  			End Select
  			Function = 0
  			Exit Function
  			
  		Case WM_VSCROLL 
  			Select Case LoWord(wParam) 				
  				Case SB_THUMBTRACK
  					If this.onChange Then this.onChange(HIWORD(wParam))
  				Case SB_BOTTOM, SB_LINEDOWN, SB_LINEUP, SB_TOP
  					nPos = SendMessage(this.Handle, TBM_GETPOS, 0, 0)
  					If this.onChange Then this.onChange(nPos)
  				Case SB_ENDSCROLL
  					nPos = SendMessage(this.Handle, TBM_GETPOS, 0, 0)
  					If this.onChange Then this.onChange(nPos)	
  			End Select
  			Function = 0
  			Exit Function
  	End Select
   
    Function = DefWindowProc(hWnd,uMsg,wParam,lParam)  
End Function

Sub FTrackbar.Create(ByVal hParent As HWND,  ByVal x As Integer,ByVal y As Integer,ByVal w As Integer,ByVal h As Integer )
	
	Dim As ZString * 32 szClass
   Dim As HINSTANCE hInst
 	
   szClass     = "FB_CONTROL"
   hInst 		= GetModuleHandle(0)
   
    this.CtHandle = CreateWindowEx( WS_EX_CONTROLPARENT  , @szClass , "", WS_VISIBLE OR WS_CHILD  , x, y, w , h , _
                          hParent , NULL, hInst , NULL )

   SetWindowLong(this.CtHandle ,GWL_USERDATA,CINT(@This)) ' Zeiger diese Instanz

   IF this.CtHandle  THEN
        this.Left    = x
        this.Top     = y
        this.Width   = w
        this.Height  = h
        this.Parent  = hParent
   ELSE
        MessageBox(0,"Fehler - Create UPDOWN","Fehler",MB_ICONERROR)
        EXIT SUB
   END If
  	
	this.Handle = CreateWindowEx( this.ExStyle , TRACKBAR_CLASS ,"" , this.Style , 0, 0, w, h , this.CtHandle ,NULL, hInst, NULL)
	this.Orientation = 0
   If this.Handle = 0 Then   	
   	MessageBox(0,"Create Trackbar ist fehl geschlagen","Fehler",MB_ICONERROR)
   EndIf
   
End Sub
sub FTrackbar.Range(ByVal min As  USHORT ,ByVal max As  USHORT )
	If this.Handle Then
		SendMessage(this.Handle,TBM_SETRANGE ,TRUE, MAKELONG(min, max))
		RePaint
	EndIf
End Sub